package com.jz.dm.common.base;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.models.enity
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: BaseObject
 * @DATE: 2020-12-22/14:03
 * @DAY_NAME_SHORT: 周二
 * @Description: 日期处理公共类
 **/
@Data
public class BaseObject implements Serializable {

    /**
     * 主健ID
     */
    @ApiModelProperty("主健ID")
    @TableId(value = "id", type = IdType.AUTO)
    private Long id;

    /**
     * 创建日期
     */
    @ApiModelProperty("创建日期")
    @TableField("create_date")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date createDate;


    /**
     * 创建人
     */
    @ApiModelProperty("创建人")
    @TableField("create_user")
    private String createUser;

    /**
     * 更新人
     */
    @ApiModelProperty("更新人")
    @TableField("update_user")
    private String updateUser;

    /**
     * 更新日期
     */
    @ApiModelProperty("更新日期")
    @TableField("update_date")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date updateDate;

    /**
     * 是否删除
     */
    @TableField("is_deleted")
    private Integer isDeleted;

    /**
     * 备注
     */
    @TableField("remark")
    private String remark;
}
