package com.jz.dm.common.enums.auth;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.common.enums.auth
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: AuthModeEnum
 * @DATE: 2020-12-26/23:53
 * @DAY_NAME_SHORT: 周六
 * @Description: 认证方式枚举
 **/
public enum AuthModeEnum {
    /**
     * 按次调用
     */
    POWER_CALL_MODE("按次调用"),

    /**
     * 按时间调用'
     */
    RECORD_TIME_MODE("按时间调用"),

    /**
     * 永久有效'
     */
    PERMANENT_TIME_MODE("永久有效");

    private String text;

    AuthModeEnum(String text) {
        this.text = text;
    }

    public String getText() {
        return text;
    }

    public static AuthModeEnum fromTypeModeName(String typeName) {
        for (AuthModeEnum type : AuthModeEnum.values()) {
            if (type.name().equals(typeName)) {
                return type;
            }
        }
        return null;
    }
}
