/**
 * Copyright (c) 2011-2019 All Rights Reserved.
 */
package com.jz.dm.config;

import com.jz.common.utils.RedisUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;

/**
 * @author Admin
 * @version $Id: MapLock.java 2019年10月26日 下午5:27:52 $
 */
@Component
public class ReentrantRedisLock {
    //获取尝试时间
    private final String LOCK = "lock:";
    @Resource
    private RedisTemplate<String, String> redisTemplate;
    @Value("${server.port}")
    private String port;

    @Autowired
    private RedisUtils redisUtils;

    /**
     * 判断是否存在
     *
     * @return
     */
    public synchronized boolean tryLock(String value) {
        return redisUtils.setIfAbsent(LOCK + value, value, 2);
    }

    public synchronized boolean tryLock(String value, long minutes) {
        return redisUtils.setIfAbsent(LOCK + value, value, minutes);
    }

    /**
     * 处理完成清除
     */
    public void unlock(String value) {
        redisTemplate.delete(LOCK + value);
    }
}
