package com.jz.dm.filter;

import com.jz.dm.models.enity.GatewayRequest;
import com.jz.dm.models.enity.GatewayResponse;
import com.jz.dm.models.enity.RequestContext;
import org.springframework.core.Ordered;


/**
 * 抽象过滤器
 * @author key
 */
public abstract class AbstractFilter implements Filter, Ordered {

    @Override
    public void doFilter(GatewayRequest request, GatewayResponse response, FilterChain chain) {
        RequestContext context = RequestContext.getCurrentContext();
        if (context.isExcludeFilter(getFilterName())) {
            chain.doFilter(request, response);
        } else {
            internalDoFilter(request, response, chain);
        }
    }

    /**
     * 执行过滤
     * 
     * @param request
     * @param response
     * @param chain
     */
    protected abstract void internalDoFilter(GatewayRequest request, GatewayResponse response,
                                             FilterChain chain);

}
