package com.jz.dm.filter;


import com.jz.dm.models.enity.GatewayRequest;
import com.jz.dm.models.enity.GatewayResponse;

/**
 * 过滤器
 *
 * @author key
 */
public interface Filter {

    /** 
     * Returns the filter-name of this filter as defined in the deployment
     * descriptor.
     * @return
     */
    public String getFilterName();

    /**
     * 执行过滤
     * 
     * @param request gateway request
     * @param response gateway response
     * @param chain filter chain
     */
    void doFilter(GatewayRequest request, GatewayResponse response, FilterChain chain);
}
