package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.jz.dm.common.base.BaseObject;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
* @Description:
* @Author: Mr.zhang
* @Date: 2020-12-23
*/
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_auth")
public class ApiAuth extends BaseObject implements Serializable {

	/**
	* api信息表id
	*/
	@TableField("api_interface_id")
    private Long apiInterfaceId;

	/**
	* api组织id
	*/
	@TableField("api_org_id")
    private Long apiOrgId;

	/**
	* 授权类型:1.数据银行购买 2.dmp授权
	*/
	@TableField("auth_type")
    private String authType;

	/**
	* 授权码
	*/
	@TableField("auth_code")
    private String authCode;

	/**
	* 盐值
	*/
	@TableField("salt")
    private String salt;

	///**
	//* 组织id
	//*/
	//@TableField("org_id")
    //private Long orgId;

	/**
	* 授权方式:1.按次调用 2.按月调用 3.按季调用 4.按年调用
	*/
	@TableField("auth_mode")
    private String authMode;

	/**
	* 开始时间
	*/
	@ApiModelProperty("开始时间")
	@TableField("valid_start_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date validStartTime;

	/**
	* 结束时间
	*/
	@ApiModelProperty("结束时间")
	@TableField("valid_end_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date validEndTime;

	/**
	* 状态(1-正常 2-作废)
	*/
	@TableField("status")
    private String status;


}
