package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
* @Description:
* @Author: Mr.zhang
* @Date: 2020-12-23
*/
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_direction")
public class ApiDirection implements Serializable {

	/**
	 * 主健ID
	 */
	@ApiModelProperty("主健ID")
	@TableId(value = "id", type = IdType.AUTO)
	private Long id;
	/**
	* 字典key
	*/
	@TableField("`key`")
    private String key;

	/**
	* 字典value
	*/
	@TableField("`value`")
    private String value;

	/**
	* 字典编码
	*/
	@TableField("`code`")
    private String code;

	/**
	* 父节点
	*/
	@TableField("parent")
    private String parent;

	/**
	* 字典类型
	*/
	@TableField("direction_type")
    private String directionType;

	/**
	* is_enabled
	*/
	@TableField("`level`")
    private Integer level;


	/**
	* 是否启用:UNABLE 停用，ENABLE 启用
	*/
	@TableField("is_enabled")
    private String isEnabled;

	/**
	 * 创建日期
	 */
	@ApiModelProperty("创建日期")
	@TableField("create_date")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createDate;


	/**
	 * 创建人
	 */
	@ApiModelProperty("创建人")
	@TableField("create_user")
	private String createUser;


	/**
	 * 是否删除
	 */
	@TableField("is_deleted")
	private Integer isDeleted;
}
