package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jz.dm.common.base.BaseObject;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;


/**
 * @Description:
 * @Author: Mr.zhang
 * @Date: 2020-12-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_interface")
public class ApiInterface extends BaseObject implements Serializable {


	/**
	* api唯一标识
	*/
	@TableField("api_key")
    private String apiKey;

	/**
	* api名称
	*/
	@TableField("api_name")
    private String apiName;

	/**
	* api描述
	*/
	@TableField("api_desc")
    private String apiDesc;

	/**
	* api请求协议：http，https
	*/
	@TableField("api_protocl")
    private String apiProtocl;

	/**
	* api类型:1 数据银行制作API  2 数据银行制作数据包, 3 API实时接入 6 标签查询 9自定义'
	*/
	@TableField("api_type")
    private String apiType;

	/**
	 * 请求地址
	 */
	@TableField("api_path")
	private String apiPath;
	/**
	* 目标url
	*/
	@TableField("target_url")
    private String targetUrl;
	/**
	* 接入类型:对应字典表key
	*/
	@TableField("join_type")
    private String joinType;
	/**
	* 测试实例
	*/
	@TableField("test_example")
    private String testExample;
	/**
	* '输出类型:flow 流形式输出, json格式输出',
	*/
	@TableField("output_type")
    private String outputType;
	/**
	* 是否分页:0 false ,1 true
	*/
	@TableField("page")
    private Boolean page;

	/**
	* 状态(1-草稿 2-发布 3-过时 4-冻结 5-失效)
	*/
	@TableField("status")
    private String status;
	/**
	* 接口功能
	*/
	@TableField("api_function")
    private String apiFunction;

	/**
	* 版本号
	*/
	@TableField("version")
    private String version;

	/**
	* 加密方式： MD5 RSA
	*/
	@TableField("sign_type")
    private String signType;

	/**
	* 超时时间
	*/
	@TableField("timeout")
    private String timeout;

	/**
	* 是否测试数据:0 否,1 是
	*/
	@TableField("is_test")
    private Integer isTest;
	/**
	* 文件夹id
	*/
	@TableField("file_id")
    private Long fileId;

}
