package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jz.dm.common.base.BaseObject;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * @Description:
 * @Author: Mr.zhang
 * @Date: 2020-12-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_org")
public class ApiOrg extends BaseObject implements Serializable {

	/**
	* 组织编码(组织唯一标识)
	*/
	@TableField("org_code")
    private String orgCode;

	/**
	* 组织名称
	*/
	@TableField("org_name")
    private String orgName;

	/**
	* 组织描述
	*/
	@TableField("org_desc")
    private String orgDesc;

	/**
	* 组织英文名称
	*/
	@TableField("org_cn_name")
    private String orgCnName;
	/**
	* 组织电话
	*/
	@TableField("org_phone")
    private String orgPhone;
	/**
	* 组织类型 OUT 外部组织 IN 内部组织
	*/
	@TableField("org_type")
    private String orgType;

	/**
	* 状态(NORMAL-正常 FREEZE-冻结 CANCEL-注销)
	*/
	@TableField("status")
    private String status;

	/**
	* 组织邮箱
	*/
	@TableField("org_mail")
    private String orgMail;

	/**
	* 组织排序
	*/
	@TableField("org_sort")
    private Integer orgSort;

	/**
	* 父类组织编码
	*/
	@TableField("parent_id")
    private String parentId;


}
