package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**api请求日志表
 * @author ybz
 *
 */
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_req_log")
public class ApiReqLog implements Serializable {


	/**
	 * 主健ID
	 */
	@ApiModelProperty("主健ID")
	@TableId(value = "id", type = IdType.AUTO)
	private Long id;

	/**
	* 请求ip
	*/
	@TableField("request_ip")
    private String requestIp;

	/**
	* apikey
	*/
	@TableField("api_key")
    private String apiKey;

	/**
	* 请求参数
	*/
	@TableField("request_params")
    private String requestParams;

	/**
	* 返回参数
	*/
	@TableField("response_params")
    private String responseParams;

	/**
	* 请求路径
	*/
	@TableField("request_url")
    private String requestUrl;

	/**
	* 请求方法
	*/
	@TableField("request_method")
    private String requestMethod;

	/**
	* 加密方式:MD5,RSA
	*/
	@TableField("encry_mode")
    private String encryMode;

	/**
	* 传输方式:POST,GET
	*/
	@TableField("trans_mode")
    private String transMode;

	/**
	* 客户请求token
	*/
	@TableField("request_token")
    private String requestToken;

	/**
	* 请求时间
	*/
	@ApiModelProperty("请求时间")
	@TableField("request_time")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private Date requestTime;

	/**
	 * 请求状态: SUCCEED 成功 ,FAIL 失败
	 */
	@TableField("status")
	private String status;



	/**
	 * 创建日期
	 */
	@ApiModelProperty("创建日期")
	@TableField("create_date")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	private Date createDate;


	/**
	 * 创建人
	 */
	@ApiModelProperty("创建人")
	@TableField("create_user")
	private String createUser;

	/**
	 * 更新人
	 */
	@ApiModelProperty("更新人")
	@TableField("update_user")
	@JsonIgnore
	private String updateUser;

	/**
	 * 更新日期
	 */
	@ApiModelProperty("更新日期")
	@TableField("update_date")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@JsonIgnore
	private Date updateDate;

	/**
	 * 是否删除
	 */
	@TableField("is_deleted")
	@JsonIgnore
	private Integer isDeleted;

	/**
	 * 备注
	 */
	@TableField("remark")
	@JsonIgnore
	private String remark;
	
}
