package com.jz.dm.models.domian;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.jz.dm.common.base.BaseObject;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**api数据源配置信息表
 * @author ybz
 *
 */
@Data
@EqualsAndHashCode(callSuper = false)
@NoArgsConstructor
@Accessors(chain = true)
@TableName("t_api_syncing_datasource")
public class ApiSyncingDatasource extends BaseObject implements Serializable {

	/**
	* 数据源类型ID
	*/
	@TableField("datasource_type")
    private Long datasourceType;

	/**
	* 数据源名称
	*/
	@TableField("datasource_name")
    private String datasourceName;

	/**
	* 数据源描述
	*/
	@TableField("datasource_desc")
    private String datasourceDesc;

	/**
	* 项目编号
	*/
	@TableField("project_id")
    private Long projectId;

	/**
	* JDBC URL
	*/
	@TableField("jdbc_url")
    private String jdbcUrl;

	/**
	* 数据库名
	*/
	@TableField("db_name")
    private String dbName;

	/**
	* 账号
	*/
	@TableField("user_name")
    private String userName;

	/**
	* 密码
	*/
	@TableField("password")
    private String password;

	/**
	* 终端信息
	*/
	@TableField("endpoint")
    private String endpoint;

	/**
	* Bucket信息
	*/
	@TableField("bucket")
    private String bucket;

	/**
	* accessId
	*/
	@TableField("access_id")
    private String accessId;

	/**
	* accessKey
	*/
	@TableField("access_key")
    private String accessKey;

	/**
	* FTP协议
	*/
	@TableField("protocol")
    private String protocol;

	/**
	* IP
	*/
	@TableField("host")
    private String host;

	/**
	* 端口
	*/
	@TableField("port")
    private String port;

	/**
	* NameNode地址
	*/
	@TableField("default_fs")
    private String defaultFs;

	/**
	* 表空间
	*/
	@TableField("table_schema")
    private String tableSchema;

	/**
	* 数据状态
	*/
	@TableField("data_status")
    private String dataStatus;

}
