package com.jz.dm.models.req.make;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.models.req.make
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: MakeApiSaveInfoReq
 * @DATE: 2020-12-29/10:00
 * @DAY_NAME_SHORT: 周二
 * @Description:
 **/
@Data
@ApiModel("保存API基本信息请求体")
public class MakeApiSaveInfoReq implements Serializable {

    @ApiModelProperty(value = "id",required = true)
    @NotNull(message = "id不能为空")
    public Long id;

    @ApiModelProperty(value = "api类型",required = true)
    @NotNull(message = "api类型不能为空")
    public String apiType;

    @ApiModelProperty(value = "apiId 等价于apiKey",required = true)
    @NotNull(message = "apiId不能为空")
    public String apiId;

    @ApiModelProperty(value = "接口描述",required = false)
    public String apiDesc;

    @ApiModelProperty(value = "api版本",required = false)
    public String version;

    @ApiModelProperty(value = "加密方式",required = true)
    @NotNull(message = "加密方式不能为空")
    public String transMode;

    @ApiModelProperty(value = "传输方式",required = true)
    @NotNull(message="传输方式不能为空")
    public String type;

    @ApiModelProperty(value = "目标地址",required = true)
    @NotNull(message="目标地址不能为空")
    public String targetUrl;

    @ApiModelProperty(value = "超时时间",required = true)
    @NotNull(message="超时时间不能为空")
    public String timeout;

    @ApiModelProperty(value = "api描述",required = false)
    public String apiFunction;

    @ApiModelProperty(value = "项目编号",required = true)
    @NotNull(message="项目编号不能为空")
    public String projectId;

    @ApiModelProperty(value = "列",required = false)
    public String columnCode;

    @ApiModelProperty(value = "状态",required = false)
    public String status;


}
