package com.jz.dm.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.jz.common.utils.Result;
import com.jz.dm.models.domian.ApiReqLog;
import com.jz.dm.models.req.LogInfoDetailReq;
import com.jz.dm.models.req.LogInfoListReq;
import net.sf.json.JSONObject;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.service
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: ApiLogService
 * @DATE: 2020-12-25/14:29
 * @DAY_NAME_SHORT: 周五
 * @Description:
 **/
public interface ApiLogService {
    /**
     * 查询日志列表
     * @param req
     * @return
     */
    IPage<ApiReqLog> listApiLog(LogInfoListReq req);

    /**
     * 获取日志详情信息
     * @param req
     * @return
     */
    Result getApiLogDetail(LogInfoDetailReq req);

    /**
     * 保存日志信息
     * @param reqLog
     */
    void insetLogInfo(ApiReqLog reqLog);

    /**
     * 根据id更新日志
     * @param id
     * @param jsonObject
     */
    void updateLog(Long id, JSONObject jsonObject);
}
