package com.jz.dm.service;

import com.jz.common.utils.Result;
import com.jz.dm.models.domian.ApiAuth;
import com.jz.dm.models.req.auth.*;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.service
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: AuthService
 * @DATE: 2020-12-23/16:46
 * @DAY_NAME_SHORT: 周三
 * @Description:
 **/
public interface AuthService {
    /**
     * 认证列表
     * @param req
     * @return
     */
    Result getAuthListInfo(AuthListInfoReq req);

    /**
     * 获取认证详情信息
     * @param req
     * @return
     */
    Result getAuthDetailInfo(AuthDetailInfoReq req);

    /**
     * 添加Dmp用户认证
     * @param req
     * @return
     */
    Result addDmpUserApiAuth(AuthUserApiReq req);

    /**
     * 添加商城用户api认证
     * @param req
     * @return
     */
    Result addMallUserApiAuth(AuthUserApiReq req);

    /**
     * 修改认证信息
     * @param req
     * @return
     */
    Result updateAuthInfo(AuthInfoUpdateReq req);

    /**
     * 盐值重置
     * @param req
     * @return
     */
    Result updateSaltInfo(SaltResetReq req);

    /**
     * 获取API授权信息
     * @param authCode
     * @param apiId
     * @return
     */
    ApiAuth getAuthUser( String authCode,Long apiId);
}
