package com.jz.dm.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.jz.common.utils.Result;
import com.jz.dm.models.domian.ApiOrg;
import com.jz.dm.models.req.organizationManage.OrganizationManageAddReq;
import com.jz.dm.models.req.organizationManage.OrganizationManageDetailQueryReq;
import com.jz.dm.models.req.organizationManage.OrganizationManageListQueryReq;
import com.jz.dm.models.req.organizationManage.OrganizationManageUpdateReq;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.service
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: OrganizationManageService
 * @DATE: 2020-12-23/16:49
 * @DAY_NAME_SHORT: 周三
 * @Description:
 **/
public interface OrganizationManageService {
    /**
     * 分页查询组织列表信息
     * @param req
     * @return
     */
    IPage<ApiOrg> listOrganization(OrganizationManageListQueryReq req);

    /**
     * 查询组织详情信息
     * @param req
     * @return
     */
    Result getOrganizationDetail(OrganizationManageDetailQueryReq req);

    /**
     * 添加组织
     * @param req
     * @return
     */
    Result add(OrganizationManageAddReq req);

    /**
     * 更新组织信息
     * @param req
     * @return
     */
    Result update(OrganizationManageUpdateReq req);

    /**
     * 根据id删除组织
     * @param id
     * @return
     */
    Result delete(Long id);

    /**
     * 获取认证组织信息
     * @param apiOrgId
     * @return
     */
    ApiOrg getAuthOrganization(Long apiOrgId);
}
