package com.jz.dm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jz.dm.common.enums.GeneralStatusTypeEnum;
import com.jz.dm.mapper.ApiDirectionMapper;
import com.jz.dm.models.domian.ApiDirection;
import com.jz.dm.service.ApiDirectionService;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.service.impl
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: ApiDirectionServiceImpl
 * @DATE: 2020-12-31/18:01
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@Service("apiDirectionService")
@Slf4j
public class ApiDirectionServiceImpl implements ApiDirectionService {

    @Resource
    private ApiDirectionMapper apiDirectionMapper;

    @Override
    public List<ApiDirection> getApiType(String parentKey) {
        QueryWrapper<ApiDirection> query = new QueryWrapper<>();
        query.eq("parent",parentKey);//父类下的所有子类
        query.eq("is_enabled", GeneralStatusTypeEnum.ENABLE);
        List<ApiDirection> apiDirections = apiDirectionMapper.selectList(query);
        apiDirections.forEach((x)->{
            if (null == x.getParent()) {
             apiDirections.remove(x.getId());
            }
        });
        return apiDirections;
    }

    @Override
    public List<ApiDirection> getDirectionVal(String key,String code) {
        QueryWrapper<ApiDirection> query = new QueryWrapper<>();
        if (StringUtils.isNotBlank(key) && StringUtils.isNotBlank(code)){
            query.eq("`key`",key);
            query.eq("`code`",code);
            query.eq("is_enabled", GeneralStatusTypeEnum.ENABLE);
        }else if (StringUtils.isNotBlank(key)){
            query.eq("`key`",key);
            query.eq("is_enabled", GeneralStatusTypeEnum.ENABLE);
        }else {
            query.eq("`code`",code);
            query.eq("is_enabled", GeneralStatusTypeEnum.ENABLE);
        }
        return apiDirectionMapper.selectList(query);
    }
}
