package com.jz.dm.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jz.dm.mapper.ApiAuthMapper;
import com.jz.dm.mapper.ApiInterfaceMapper;
import com.jz.dm.models.domian.ApiAuth;
import com.jz.dm.models.domian.ApiInterface;
import com.jz.dm.service.ApiInterfaceService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.service.impl
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: ApiInterfaceServiceImpl
 * @DATE: 2021-1-2/14:27
 * @DAY_NAME_SHORT: 周六
 * @Description:
 **/
@Service("apiInterfaceService")
@Slf4j
public class ApiInterfaceServiceImpl implements ApiInterfaceService {

    @Resource
    private ApiInterfaceMapper apiInterfaceMapper;
    @Resource
    private ApiAuthMapper apiAuthMapper;
    /**
     * 获取用户授权信息
     * @param apiKey
     * @param authCode
     * @return
     */
    @Override
    public ApiAuth getApiAuthInfo(String apiKey, String authCode) {
        QueryWrapper<ApiInterface> query = new QueryWrapper<>();
        query.eq("is_deleted",0);
        query.eq("api_key", apiKey);
        ApiInterface apiInterface = apiInterfaceMapper.selectOne(query);
        if (null != apiInterface){
            QueryWrapper<ApiAuth> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("is_deleted",0);
            queryWrapper.eq("auth_code",authCode);
            ApiAuth apiAuth = apiAuthMapper.selectOne(queryWrapper);
            if (null != apiAuth){
               return apiAuth;
            }
        }
       return null;
    }

    /**
     * 获取API信息
     * @param apiKey
     * @return
     */
    @Override
    public ApiInterface getApiInfo(String apiKey) {
        QueryWrapper<ApiInterface> query = new QueryWrapper<>();
        query.eq("is_deleted",0);
        query.eq("api_key",apiKey);
        return apiInterfaceMapper.selectOne(query);
    }

    @Override
    public ApiInterface getReqTargetInfo(String apiKey) {
        QueryWrapper<ApiInterface> query = new QueryWrapper<>();
        query.eq("api_key",apiKey);
        query.eq("is_deleted",0);
        return apiInterfaceMapper.selectOne(query);
    }
}
