package com.jz.dm.web.annotation;

import java.lang.annotation.*;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.web.annotation
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: AccessLimit
 * @DATE: 2020-12-26/17:38
 * @DAY_NAME_SHORT: 周六
 * @Description: 限流拦截器
 **/
@Inherited
@Documented
@Target({ElementType.FIELD,ElementType.TYPE,ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
public @interface AccessLimit {
    //标识 指定sec时间段内的访问次数限制
    int limit() default 5;
    //标识 时间段(秒)
    int sec() default 5;
}
