package com.jz.dm.web.binder;

import org.springframework.beans.MutablePropertyValues;
import org.springframework.web.servlet.mvc.method.annotation.ExtendedServletRequestDataBinder;

import javax.servlet.ServletRequest;
import java.util.Map;

/**
 * 参数名注解绑定
 *
 * @author key
 */
public class ParamNameAnnotationBinder extends ExtendedServletRequestDataBinder {

    private final Map<String, String> paramNamesMapping;

    public ParamNameAnnotationBinder(Object target, String objectName,
                                     Map<String, String> paramNamesMapping) {
        super(target, objectName);
        this.paramNamesMapping = paramNamesMapping;
    }

    @Override
    protected void addBindValues(MutablePropertyValues mpvs, ServletRequest request) {
        super.addBindValues(mpvs, request);
        for (Map.Entry<String, String> entry : paramNamesMapping.entrySet()) {
            String from = entry.getKey();
            String to = entry.getValue();
            if (mpvs.contains(from)) {
                mpvs.add(to, mpvs.getPropertyValue(from).getValue());
            }
        }
    }
}