package com.jz.common.bean;

import com.jz.common.enums.UserTypeEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * @ClassName: 商城用户状态信息
 * @Author: Carl
 * @Date: 2020/12/3
 * @Version:
 */
@ApiModel
public class MallCustomerApiDto implements Serializable {

    private static final long serialVersionUID = 8769496459018372044L;

    @ApiModelProperty(value = "用户id")
    private Long customerId;

    @ApiModelProperty(value = "用户类型")
    private UserTypeEnum userTypeEnum;

    @ApiModelProperty(value = "企业id")
    private Long departmentId;

    /**
     * 账户
     */
    @ApiModelProperty(value = "账户")
    private String customerAccount;

    /**
     * 用户真实姓名
     */
    @ApiModelProperty(value = "用户真实姓名")
    private String customerName;

    /**
     * 资产账户id
     */
    @ApiModelProperty(value = "资产账户id")
    private String assetsId;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public Long getCustomerId() {
        return customerId;
    }

    public void setCustomerId(Long customerId) {
        this.customerId = customerId;
    }

    public UserTypeEnum getUserTypeEnum() {
        return userTypeEnum;
    }

    public void setUserTypeEnum(UserTypeEnum userTypeEnum) {
        this.userTypeEnum = userTypeEnum;
    }

    public Long getDepartmentId() {
        return departmentId;
    }

    public void setDepartmentId(Long departmentId) {
        this.departmentId = departmentId;
    }

    public String getCustomerAccount() {
        return customerAccount;
    }

    public void setCustomerAccount(String customerAccount) {
        this.customerAccount = customerAccount;
    }

    public String getCustomerName() {
        return customerName;
    }

    public void setCustomerName(String customerName) {
        this.customerName = customerName;
    }

    public String getAssetsId() {
        return assetsId;
    }

    public void setAssetsId(String assetsId) {
        this.assetsId = assetsId;
    }
}
