package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 数据商品(TDataGoods)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:30
 */
@TableName("t_data_goods")
@ApiModel
@Data
public class DataGoods implements Serializable {
    private static final long serialVersionUID = 938517475031285541L;
    /**
     * 数据商品id
     */
    @TableId(value = "data_goods_id", type = IdType.AUTO)
    private Long dataGoodsId;
    /**
     * 商品分类id（行业）
     */
    private Long categoryId;
    /**
     * 数据商户id
     */
    private Long userId;

    @ApiModelProperty(value = "唯一数据商品标识")
    private String apiOpenId;
    /**
     * 数据商品名称
     */
    private String dataName;
    /**
     * 数据类型：01api，02数据包
     */
    private String dataType;
    /**
     * 数据商品标签
     */
    private String dataLabel;
    /**
     * 数据商品图片
     */
    private String dataPicture;
    /**
     * 数据商品价格
     */
    private BigDecimal dataPrice;
    /**
     * 优惠价格
     */
    private BigDecimal discountPrice;
    /**
     * 价格类型：01免费，02收费
     */
    private String priceType;
    /**
     * 商品规格
     */
    private String goodsStandards;
    /**
     * 数据状态：01预售，02在售中，03下架，04上架
     */
    private String dataStatus;
    /**
     * 审核状态：01待审核，02已审核，03未通过
     */
    private String auditStatus;
    /**
     * 清洗规则（脱敏校验）
     */
    private String cleanRule;
    /**
     * 驳回原因
     */
    private String rejectReason;
    /**
     * 审核人
     */
    private String auditPerson;
    /**
     * 审核时间
     */
    private Date auditTime;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 更新时间
     */
    private Date uptTime;
    /**
     * 更新人
     */
    private String uptPerson;
    /**
     * 删除标识
     */
    private String delFlag;
    /**
     * 年（元）
     */
    private BigDecimal yearType;
    /**
     * 季（元）
     */
    private BigDecimal seasonType;
    /**
     * 月（元）
     */
    private BigDecimal monthType;
    /**
     * 次（元）
     */
    private BigDecimal secondType;




}