package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.util.Date;

/**
 * 定义api(DefinitionApi)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:33
 */
@TableName("t_definition_api")
@ApiModel
public class DefinitionApi implements Serializable {
    private static final long serialVersionUID = 816553116583412022L;
    /**
     * 定义api接口id
     */
    private Long definitionApiId;
    /**
     * 应用名称
     */
    private String applyApiName;
    /**
     * api_id
     */
    private String applyApiId;
    /**
     * 接口描述
     */
    private String interfaceDesc;
    /**
     * 版本号
     */
    private String versionNumber;
    /**
     * 加密方式
     */
    private String encryMode;
    /**
     * 传输方式
     */
    private String transMode;
    /**
     * 正式地址
     */
    private String formalAddress;
    /**
     * 超时时间
     */
    private Date overTime;
    /**
     * 功能
     */
    private String apiFunction;
    /**
     * 请求方式
     */
    private String requestType;
    /**
     * 每单接口调用频率
     */
    private String oneCallFrequency;
    /**
     * 整个接口的调用频率
     */
    private String allCallFrequency;
    /**
     * 客户请求token
     */
    private String requestToken;
    /**
     * 盐值
     */
    private String saltValue;
    /**
     * 处理状态：01待处理，02ETL处理中，03ETL处理完成，04接口生成完成
     */
    private String handleStatus;
    /**
     * 处理结果：成功/失败码
     */
    private String handleResult;
    /**
     * 创建时间
     */
    private Date creTime;


    public Long getDefinitionApiId() {
        return definitionApiId;
    }

    public void setDefinitionApiId(Long definitionApiId) {
        this.definitionApiId = definitionApiId;
    }

    public String getApplyApiName() {
        return applyApiName;
    }

    public void setApplyApiName(String applyApiName) {
        this.applyApiName = applyApiName;
    }

    public String getApplyApiId() {
        return applyApiId;
    }

    public void setApplyApiId(String applyApiId) {
        this.applyApiId = applyApiId;
    }

    public String getInterfaceDesc() {
        return interfaceDesc;
    }

    public void setInterfaceDesc(String interfaceDesc) {
        this.interfaceDesc = interfaceDesc;
    }

    public String getVersionNumber() {
        return versionNumber;
    }

    public void setVersionNumber(String versionNumber) {
        this.versionNumber = versionNumber;
    }

    public String getEncryMode() {
        return encryMode;
    }

    public void setEncryMode(String encryMode) {
        this.encryMode = encryMode;
    }

    public String getTransMode() {
        return transMode;
    }

    public void setTransMode(String transMode) {
        this.transMode = transMode;
    }

    public String getFormalAddress() {
        return formalAddress;
    }

    public void setFormalAddress(String formalAddress) {
        this.formalAddress = formalAddress;
    }

    public Date getOverTime() {
        return overTime;
    }

    public void setOverTime(Date overTime) {
        this.overTime = overTime;
    }

    public String getApiFunction() {
        return apiFunction;
    }

    public void setApiFunction(String apiFunction) {
        this.apiFunction = apiFunction;
    }

    public String getRequestType() {
        return requestType;
    }

    public void setRequestType(String requestType) {
        this.requestType = requestType;
    }

    public String getOneCallFrequency() {
        return oneCallFrequency;
    }

    public void setOneCallFrequency(String oneCallFrequency) {
        this.oneCallFrequency = oneCallFrequency;
    }

    public String getAllCallFrequency() {
        return allCallFrequency;
    }

    public void setAllCallFrequency(String allCallFrequency) {
        this.allCallFrequency = allCallFrequency;
    }

    public String getRequestToken() {
        return requestToken;
    }

    public void setRequestToken(String requestToken) {
        this.requestToken = requestToken;
    }

    public String getSaltValue() {
        return saltValue;
    }

    public void setSaltValue(String saltValue) {
        this.saltValue = saltValue;
    }

    public String getHandleStatus() {
        return handleStatus;
    }

    public void setHandleStatus(String handleStatus) {
        this.handleStatus = handleStatus;
    }

    public String getHandleResult() {
        return handleResult;
    }

    public void setHandleResult(String handleResult) {
        this.handleResult = handleResult;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

}