package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.util.Date;

/**
 * API参数表(DefinitionApiParams)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:33
 */
@TableName("t_definition_api_params")
@ApiModel
public class DefinitionApiParams implements Serializable {
    private static final long serialVersionUID = -53949033620241193L;
    /**
     * api参数id
     */
    private Long apiParamsId;
    /**
     * 定义api接口id
     */
    private Long definitionApiId;
    /**
     * 参数名称
     */
    private String paramsName;
    /**
     * 字段
     */
    private String fieldName;
    /**
     * 类型
     */
    private String fieldType;
    /**
     * 示例值
     */
    private String exampleValue;
    /**
     * 默认值
     */
    private String defaultValue;
    /**
     * 是否必选
     */
    private String ifChoose;
    /**
     * 描述
     */
    private String fieldDesc;
    /**
     * 参数类型
     */
    private String paramsType;
    /**
     * 业务类型：01公共参数，02业务参数
     */
    private String serviceType;
    /**
     * 创建时间
     */
    private Date creTime;


    public Long getApiParamsId() {
        return apiParamsId;
    }

    public void setApiParamsId(Long apiParamsId) {
        this.apiParamsId = apiParamsId;
    }

    public Long getDefinitionApiId() {
        return definitionApiId;
    }

    public void setDefinitionApiId(Long definitionApiId) {
        this.definitionApiId = definitionApiId;
    }

    public String getParamsName() {
        return paramsName;
    }

    public void setParamsName(String paramsName) {
        this.paramsName = paramsName;
    }

    public String getFieldName() {
        return fieldName;
    }

    public void setFieldName(String fieldName) {
        this.fieldName = fieldName;
    }

    public String getFieldType() {
        return fieldType;
    }

    public void setFieldType(String fieldType) {
        this.fieldType = fieldType;
    }

    public String getExampleValue() {
        return exampleValue;
    }

    public void setExampleValue(String exampleValue) {
        this.exampleValue = exampleValue;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public String getIfChoose() {
        return ifChoose;
    }

    public void setIfChoose(String ifChoose) {
        this.ifChoose = ifChoose;
    }

    public String getFieldDesc() {
        return fieldDesc;
    }

    public void setFieldDesc(String fieldDesc) {
        this.fieldDesc = fieldDesc;
    }

    public String getParamsType() {
        return paramsType;
    }

    public void setParamsType(String paramsType) {
        this.paramsType = paramsType;
    }

    public String getServiceType() {
        return serviceType;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

}