package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 企业客户充值记录(TFinanceCustomerBalance)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:38
 */
@TableName("t_finance_customer_balance")
@ApiModel
public class FinanceCustomerBalance implements Serializable {
    private static final long serialVersionUID = -13102196689933511L;
    /**
     * 充值id
     */
    private Long customerBalanceId;
    /**
     * 企业客户资产id
     */
    private Long assetsId;
    /**
     * 充值金额
     */
    private BigDecimal balanceMoney;
    /**
     * 备注
     */
    private String remark;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 删除标识
     */
    private String delFlag;
    /**
     * 审核状态：01待审核，02审核通过，03未通过
     */
    private String auditStatus;
    /**
     * 审核意见
     */
    private String rejectReason;


    public Long getCustomerBalanceId() {
        return customerBalanceId;
    }

    public void setCustomerBalanceId(Long customerBalanceId) {
        this.customerBalanceId = customerBalanceId;
    }

    public Long getAssetsId() {
        return assetsId;
    }

    public void setAssetsId(Long assetsId) {
        this.assetsId = assetsId;
    }

    public BigDecimal getBalanceMoney() {
        return balanceMoney;
    }

    public void setBalanceMoney(BigDecimal balanceMoney) {
        this.balanceMoney = balanceMoney;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

}