package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;

/**
 * 功能菜单(SysMenu)实体类
 *
 * @author Bellamy
 * @since 2020-11-29 14:30:23
 */
@TableName("t_sys_menu")
@ApiModel
public class SysMenu implements Serializable {
    private static final long serialVersionUID = 256732259347445947L;
    /**
     * 菜单ID
     */
    @TableId(value = "menu_id",type = IdType.AUTO)
    private Long menuId;
    /**
     * 菜单名称
     */
    @ApiModelProperty(value = "菜单名称")
    private String menuName;
    /**
     * 菜单路径
     */
    @ApiModelProperty(value = "菜单路径url")
    private String url;
    /**
     * 父级id
     */
    @ApiModelProperty(value = "父级id")
    private Long parentId;
    /**
     * 是否为子节点:Y是，N否
     */
    @ApiModelProperty(value = "是否为子节点:Y是，N否")
    private String ifChild;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date creTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private Long crePerson;
    /**
     * 删除标识：Y删除，N未删除
     */
    @ApiModelProperty(value = "删除标识：Y删除，N未删除")
    private String delFlag;


    public Long getMenuId() {
        return menuId;
    }

    public void setMenuId(Long menuId) {
        this.menuId = menuId;
    }

    public String getMenuName() {
        return menuName;
    }

    public void setMenuName(String menuName) {
        this.menuName = menuName;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public Long getParentId() {
        return parentId;
    }

    public void setParentId(Long parentId) {
        this.parentId = parentId;
    }

    public String getIfChild() {
        return ifChild;
    }

    public void setIfChild(String ifChild) {
        this.ifChild = ifChild;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public Long getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(Long crePerson) {
        this.crePerson = crePerson;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

}