package com.jz.common.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.util.Date;

/**
 * 平台系统用户表(SysUser)实体类
 *
 * @author Bellamy
 * @since 2020-11-29 14:30:26
 */
@TableName("t_sys_user")
@ApiModel
public class SysUser implements Serializable {
    private static final long serialVersionUID = 340254540407496782L;
    /**
     * 平台用户id
     */
    @TableId(value = "user_id",type = IdType.AUTO)
    private Long userId;
    /**
     * 组织机构id
     */
    private Long orgId;
    /**
     * 用户姓名
     */
    private String userName;
    /**
     * 账户
     */
    private String account;
    /**
     * 密码
     */
    private String password;
    /**
     * 供应商编号
     */
    private String supplierCode;
    /**
     * 供应商名称（店铺名称）
     */
    private String supplierName;
    /**
     * 电话
     */
    private String telephone;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 删除标识
     */
    private String delFlag;


    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public String getAccount() {
        return account;
    }

    public void setAccount(String account) {
        this.account = account;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getSupplierCode() {
        return supplierCode;
    }

    public void setSupplierCode(String supplierCode) {
        this.supplierCode = supplierCode;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

}