package com.jz.common.enums;

/**
 * 审核状态
 *
 * @author Bellamy
 * @since 2020-11-30 14:30:23
 */
public enum AuditStatusEnum {
    /**
     * 待审核
     */
    DSH("DSH", "01"),

    /**
     * 已审核
     */
    YSH("YSH", "02"),

    /**
     * 未通过
     */
    WTG("WTG", "03"),
    ;
    private String code;

    private String value;

    AuditStatusEnum(String code, String value) {
        this.code = code;
        this.value = value;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public static AuditStatusEnum get(String code) {
        if (code == null) {
            return null;
        }
        for (AuditStatusEnum status : values()) {
            if (status.getCode().equalsIgnoreCase(code)) {
                return status;
            }
        }
        return null;
    }


}
