package com.jz.common.enums;

/**
 * 订单方式
 *
 * @author Bellamy
 * @since 2020-12-09 14:30:23
 */
public enum OrderMethodEnum {
    /**
     * 年
     */
    YEAR("YEAR", "01"),

    /**
     * 季
     */
    SEASON("SEASON", "02"),

    /**
     * 月
     */
    MONTH("MONTH", "03"),

    /**
     * 次
     */
    SECOND("SECOND", "04"),
    ;
    private String code;

    private String value;

    OrderMethodEnum(String code, String value) {
        this.code = code;
        this.value = value;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public static OrderMethodEnum get(String code) {
        if (code == null) {
            return null;
        }
        for (OrderMethodEnum status : values()) {
            if (status.getCode().equalsIgnoreCase(code)) {
                return status;
            }
        }
        return null;
    }


}
