package com.jz.common.enums;

/**
 * 交易流水类型
 *
 * @author Bellamy
 * @since 2020-12-07 14:30:23
 */
public enum TradeFlowEnum {
    /**
     * 提现
     */
    TX("TX", "01"),

    /**
     * 充值
     */
    CZ("CZ", "02"),

    /**
     * 付款（订单）
     */
    FK("FK", "03"),

    /**
     * 收款
     */
    SK("SK", "04"),

    /**
     * 续费
     */
    XF("XF", "05"),
    ;
    private String code;

    private String value;

    TradeFlowEnum(String code, String value) {
        this.code = code;
        this.value = value;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public static TradeFlowEnum get(String code) {
        if (code == null) {
            return null;
        }
        for (TradeFlowEnum status : values()) {
            if (status.getCode().equalsIgnoreCase(code)) {
                return status;
            }
        }
        return null;
    }


}
