package com.jz.common.utils;

import java.io.Serializable;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * 工具类
 */

public class CommonsUtil implements Serializable {

    /**
     * 返回字符串当前日期时间
     *
     * @return
     */
    public static String getCurrentTime() {
        String curDateFormat = "yyyy-MM-dd HH:mm:ss";
        SimpleDateFormat sdf = new SimpleDateFormat(curDateFormat);
        String sd = sdf.format(new Date());
        return sd;
    }

    /**
     * 根据指定的格式日期，返回日期时间
     *
     * @param strDate
     * @param strDateformat
     * @return
     */
    public static Date getString2Date(String strDate, String strDateformat) {
        SimpleDateFormat sdf = null;
        if (strDateformat != "" || strDateformat != null) {
            sdf = new SimpleDateFormat(strDateformat);
        }
        Date dt = null;
        try {
            dt = sdf.parse(strDate);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return dt;
    }

    /**
     * 按指定格式返回字符串当前日期时间
     *
     * @return
     */
    public static String getDate2String(String curDateFormat,Date date) {
        SimpleDateFormat sdf = new SimpleDateFormat(curDateFormat);
        String sd = sdf.format(date);
        return sd;
    }
}
