package com.jz.common.utils;

import java.util.Calendar;
import java.util.Random;

/**
 * @ClassName:
 * @Author: Carl
 * @Date: 2020/12/31
 * @Version:
 */
public class NumberUtils {

    // 制作订单编号
    public static String getOrderNumber(String userId) {
        Calendar ca = Calendar.getInstance();
        int minute = ca.get(Calendar.MINUTE);//分
        int hour = ca.get(Calendar.HOUR);//小时
        int second = ca.get(Calendar.SECOND);//秒
        String format1 = String.format("%02d", hour);
        String format2 = String.format("%02d", minute);
        String format3 = String.format("%02d", second);

        return format1 + getRandomString(4)+format2 +userId+ format3;
    }


    //制作交易流水编号
    public static String getDealNum() {
        Calendar ca = Calendar.getInstance();
        int year = ca.get(Calendar.YEAR);
        int month = ca.get(Calendar.MONTH) + 1;
        int day = ca.get(Calendar.DAY_OF_MONTH);
        int hour = ca.get(Calendar.HOUR);//小时
        int minute = ca.get(Calendar.MINUTE);//分
        int second = ca.get(Calendar.SECOND);//秒
//        String format1 = String.format("%02d", year);
        String format1 = String.format("%02d", month);
        String format2 = String.format("%02d", day);
        String format3 = String.format("%02d", minute);
        String format4 = String.format("%02d", hour);
        String format5 = String.format("%02d", second);


        return year+format1+format2+format3+ getRandomString(8)+ format4+format5;
    }

    public static String getRandomString(int length) {
        String str = "1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        Random random = new Random();

        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < length; i++) {

            int number = random.nextInt(62);

            sb.append(str.charAt(number));
        }
        return sb.toString();
    }


    /**
     * 随机获取英文+数字（用户名）
     *
     * @param engCode 小写英文的数量
     * @param numCode 数字的数量
     * @return
     */
    public static String verifyUserName(int engCode, int numCode) {
        //声明一个StringBuffer存储随机数
        StringBuffer sb = new StringBuffer();
        char[] englishCodeArray = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
                'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
        char[] numCodeArray = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'};
        Random random = new Random();
        //获取英文
        for (int i = 0; i < engCode; i++) {
            char num = englishCodeArray[random.nextInt(englishCodeArray.length)];
            sb.append(num);
        }
        //获取数字
        for (int i = 0; i < numCode; i++) {
            char num = numCodeArray[random.nextInt(numCodeArray.length)];
            sb.append(num);
        }
        return sb.toString();

    }

//    public static void main(String[] args) {
//
//        System.out.println(getOrderNumber("00001"));
//        System.out.println(getDealNum());
//    }
}