package com.jz.dm.mall.moduls.controller.company.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.mall.moduls.controller.company.bean
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: CompanyUpdateReq
 * @USER: key
 * @DATE: 2020-12-3/15:32
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@Data
@ApiModel
public class CompanyUpdateReq implements Serializable {

    @ApiModelProperty(name = "企业ID",required = true)
    @NotNull(message = "企业Id不能为空")
    private Long departmentId;

    @ApiModelProperty(name = "企业名称",required = true)
    @NotNull(message = "企业名称不能为空")
    private String departmentName;

    @ApiModelProperty(name = "省",required = true)
    @NotNull(message = "省信息不能为空")
    private String province;
    @ApiModelProperty(name = "市",required = true)
    @NotNull(message = "市信息不能为空")
    private String city;

    @ApiModelProperty(name = "公司详细地址",required = true)
    @NotNull(message = "公司详细地址不能为空")
    private String registeredAddress;

    @ApiModelProperty(name = "统一社会编码",required = true)
    @NotNull(message = "统一社会编码不能忍为空")
    private String unifiedCreditCode;
    @ApiModelProperty(name = "营业执照照片",required = true)
    @NotNull(message = "营业执照照片不能忍为空")
    private String businessLicense;

    @ApiModelProperty(name = "开户银行",required = true)
    @NotNull(message = "开户银行不能为空")
    private String bankName;
    @ApiModelProperty(name = "银行账户",required = true)
    @NotNull(message = "银行账户不能忍为空")
    private String bankCardNumber;

    @ApiModelProperty(name = "联系人名称",required = true)
    @NotNull(message = "联系人名称不能为空")
    private String linkman;
    @ApiModelProperty(name = "联系人电话",required = true)
    @NotNull(message = "联系人电话不能为空")
    private String telephone;

    @ApiModelProperty(name = "登录用户id",hidden = true)
    private Long loginId;
    @ApiModelProperty(name = "登录用户名称",hidden = true)
    private String loginName;
}
