package com.jz.dm.mall.moduls.controller.finance.bean;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 企业客户交易流水 收支情况
 *
 * @author makejava
 * @since 2020-12-01 10:41:39
 */
@ApiModel(value = "每天收支情况明细返回对象", description = "每天收支情况明细返回对象")
public class EveryTradeFlowDto {
    /**
     * 交易流水编号
     */
    @ApiModelProperty(value = "交易流水编号")
    private String tradeFlowNumber;
    /**
     * 交易流水金额
     */
    @ApiModelProperty(value = "交易流水金额")
    private BigDecimal tradeMoney;
    /**
     * 交易类型：01提现，02充值，03付款，04收款，05续费
     */
    @ApiModelProperty(value = "交易类型")
    private String tradeType;
    /**
     * 交易类型id
     */
    @ApiModelProperty(value = "交易类型：01提现，02充值，03付款，04收款，05续费")
    private String tradeTypeId;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="HH:mm:ss")
    private Date creTime;

    /**
     * 数据名称
     */
    @ApiModelProperty(value = "数据名称")
    private String dataName;
    /**
     * 订单方式
     */
    @ApiModelProperty(value = "订单方式")
    private String purchaseMethod;
    /**
     * 余额
     */
    @ApiModelProperty(value = "余额")
    private BigDecimal balanceMoney;

    public String getTradeFlowNumber() {
        return tradeFlowNumber;
    }

    public void setTradeFlowNumber(String tradeFlowNumber) {
        this.tradeFlowNumber = tradeFlowNumber;
    }

    public BigDecimal getTradeMoney() {
        return tradeMoney;
    }

    public void setTradeMoney(BigDecimal tradeMoney) {
        this.tradeMoney = tradeMoney;
    }

    public String getTradeType() {
        return tradeType;
    }

    public void setTradeType(String tradeType) {
        this.tradeType = tradeType;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getTradeTypeId() {
        return tradeTypeId;
    }

    public void setTradeTypeId(String tradeTypeId) {
        this.tradeTypeId = tradeTypeId;
    }

    public String getDataName() {
        return dataName;
    }

    public void setDataName(String dataName) {
        this.dataName = dataName;
    }

    public String getPurchaseMethod() {
        return purchaseMethod;
    }

    public void setPurchaseMethod(String purchaseMethod) {
        this.purchaseMethod = purchaseMethod;
    }

    public BigDecimal getBalanceMoney() {
        return balanceMoney;
    }

    public void setBalanceMoney(BigDecimal balanceMoney) {
        this.balanceMoney = balanceMoney;
    }
}