package com.jz.dm.mall.moduls.controller.finance.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 提现申请(TFinanceCashOut)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:37
 */
@ApiModel(value = "接口请求参数对象", description = "接口请求参数对象")
public class FinanceCashOutRequest implements Serializable {
    private static final long serialVersionUID = 584623943576096734L;

    /**
     * 资产id
     */
    @ApiModelProperty(value = "企业资产id")
    private Long assetsId;
    /**
     * 提现金额
     */
    @ApiModelProperty(value = "提现金额")
    private BigDecimal cashOutMoney;

    /**
     * 备注
     */
    @ApiModelProperty(value = "提现备注")
    private String remark;

    public Long getAssetsId() {
        return assetsId;
    }

    public void setAssetsId(Long assetsId) {
        this.assetsId = assetsId;
    }

    public BigDecimal getCashOutMoney() {
        return cashOutMoney;
    }

    public void setCashOutMoney(BigDecimal cashOutMoney) {
        this.cashOutMoney = cashOutMoney;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }


}