package com.jz.dm.mall.moduls.controller.finance.bean;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 企业客户交易流水(TFinanceTradeFlow)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:39
 */
@ApiModel(value = "收支情况返回对象", description = "收支情况返回对象")
public class FinanceTradeFlowDto implements Serializable {
    private static final long serialVersionUID = -55257582310832314L;
    /**
     * 收入金额
     */
    @ApiModelProperty(value = "收入金额")
    private BigDecimal receiveMoey;
    /**
     * 提现金额
     */
    @ApiModelProperty(value = "提现金额")
    private BigDecimal cashOutMoney;
    /**
     * 充值金额
     */
    @ApiModelProperty(value = "充值金额")
    private BigDecimal rechargeMoney;
    /**
     * 支出金额
     */
    @ApiModelProperty(value = "支出金额")
    private BigDecimal payMoey;
    /**
     * 结余
     */
    @ApiModelProperty(value = "结余")
    private BigDecimal balanceMoney;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="yyyy-MM-dd")
    private Date creTime;

    public BigDecimal getReceiveMoey() {
        return receiveMoey;
    }

    public void setReceiveMoey(BigDecimal receiveMoey) {
        this.receiveMoey = receiveMoey;
    }

    public BigDecimal getCashOutMoney() {
        return cashOutMoney;
    }

    public void setCashOutMoney(BigDecimal cashOutMoney) {
        this.cashOutMoney = cashOutMoney;
    }

    public BigDecimal getRechargeMoney() {
        return rechargeMoney;
    }

    public void setRechargeMoney(BigDecimal rechargeMoney) {
        this.rechargeMoney = rechargeMoney;
    }

    public BigDecimal getPayMoey() {
        return payMoey;
    }

    public void setPayMoey(BigDecimal payMoey) {
        this.payMoey = payMoey;
    }

    public BigDecimal getBalanceMoney() {
        return balanceMoney;
    }

    public void setBalanceMoney(BigDecimal balanceMoney) {
        this.balanceMoney = balanceMoney;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }
}