package com.jz.dm.mall.moduls.controller.goods;

import com.jz.common.base.BaseController;
import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.dm.mall.moduls.controller.goods.bean.dto.MallHotRecommendGoodsDto;
import com.jz.dm.mall.moduls.service.MallHotRecommendGoodsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 热门推荐商品(TMallHotRecommendGoods)表控制层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:40
 */
@RestController
@RequestMapping("mallHotRecommendGoods")
@Api(tags = "热门商品--controller")
public class MallHotRecommendGoodsController extends BaseController {
    /**
     * 服务对象
     */
    @Autowired
    private MallHotRecommendGoodsService tMallHotRecommendGoodsService;

    @GetMapping(value = "/popularApi")
    @ApiOperation(value = "热门商品api", notes = "热门商品api展示")
    public Result<List<MallHotRecommendGoodsDto>> popularApi() {
        List<MallHotRecommendGoodsDto>  popularApiList = tMallHotRecommendGoodsService.selectByPopularApi();
        return new Result<>(true, "查询热门api成功", StatusCode.OK, popularApiList);
    }


}