package com.jz.dm.mall.moduls.controller.goods.bean.dto;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.jz.common.entity.DataGoodsApiParams;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @ClassName:  商品详情参数封装
 * @Author: Carl
 * @Date: 2020/12/8
 * @Version:
 */
@ApiModel(value = "商品详情--商品详情参数对象", description = "商品详情参数对象")
@Data
public class DataGoodsApiDto implements Serializable {

    /**
     * api商品id
     */
    @ApiModelProperty(value = "api商品id")
    private Long goodsApi;

    /**
     * 数据id
     */
    @ApiModelProperty(value = "数据id")
    private Long dataGoodsId;

    @ApiModelProperty(value = "分类名称")
    private String categoryName;

    /**
     * api参数id
     */
    @ApiModelProperty(value = "api参数id")
    private Long apiParamsId;

    /**
     * api服务名称
     */
    @ApiModelProperty(value = "api服务名称")
    private String apiName;

    /**
     * 请求类型（方式）
     */
    @ApiModelProperty(value = "请求类型（方式）")
    private String requestType;

    /**
     * api接口地址
     */
    @ApiModelProperty(value = "api接口地址")
    private String apiUrl;

    /**
     * api接口方法
     */
    @ApiModelProperty(value = "api接口方法")
    private String apiMethod;

    /**
     * api请求协议
     */
    @ApiModelProperty(value = "api请求协议")
    private String apiProtocl;

    /**
     * 返回类型
     */
    @ApiModelProperty(value = "返回类型")
    private String returnType;

    @ApiModelProperty(value = "apiKey")
    private String apiKey;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date uptTime;

    /**
     * 价格类型
     */
    @ApiModelProperty(value = "价格类型")
    private String priceType;

    @ApiModelProperty(value = "商品价格")
    private BigDecimal dataPrice;

    /**
     * 供应商名称
     */
    @ApiModelProperty(value = "供应商名称")
    private String supplierName;

    /**
     * 参数分类
     */
    @ApiModelProperty(value = "参数分类：01公共参数，02请求参数，03响应参数，04请求头参数，05状态码参数")
    private String paramsDiff;

    @ApiModelProperty(value = "年(元)")
    private BigDecimal yearType;

    @ApiModelProperty(value = "季(元)")
    private BigDecimal seasonType;

    @ApiModelProperty(value = "月(元)")
    private BigDecimal monthType;

    @ApiModelProperty(value = "次(元)")
    private BigDecimal secondType;

    /**
     * 参数名称
     */
    @ApiModelProperty(value = "参数名称")
    private String paramsName;

    /**
     * 参数类型
     */
    @ApiModelProperty(value = "参数类型")
    private String paramsTYpe;

    /**
     * 参数描述
     */
    @ApiModelProperty(value = "参数描述")
    private String paramsDesc;

    /**
     * 默认值
     */
    @ApiModelProperty(value = "默认值")
    private String defaultValue;

    /**
     * 是否必选
     */
    @ApiModelProperty(value = "是否必选：Y是，N否")
    private String ifRequird;

    /**
     * 数据类型
     */
    @ApiModelProperty(value = "数据类型")
    private String dataType;

    /**
     * api返回数据样例
     */
    @ApiModelProperty(value = "api返回数据样例")
    private String returnDataExample;

    /**
     * api请求样例
     */
    @ApiModelProperty(value = "api请求样例")
    private String requestExample;

    @ApiModelProperty(value = "参数分类数字")
    private String paramsDiffNum;


    @ApiModelProperty(value = "数据商品图片")
    private String dataPicture;

    @ApiModelProperty(value = "数据描述")
    private String dataDesc;


}
