package com.jz.dm.mall.moduls.controller.goods.bean.dto;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;


/**
 * @ClassName: 商品列表返回对象
 * @Author: Carl
 * @Date: 2020/12/9
 * @Version:
 */
@ApiModel(value = "商品列表", description = "商品列表参数对象")
public class DataGoodsListDto {

    /**
     * 数据商品id
     */
    @ApiModelProperty(value = "数据商品id")
    private Long dataGoodsId;

    /**
     * 商品分类id
     */
    @ApiModelProperty(value = "商品分类id")
    private Long categoryId;

    /**
     * 数据商品名称
     */
    @ApiModelProperty(value = "数据商品名称")
    private String dataName;

    /**
     * 分类名称
     */
    @ApiModelProperty(value = "分类名称")
    private String categoryName;

    /**
     * 数据类型
     */
    @ApiModelProperty(value = "数据类型：01api,02数据包")
    private String dataType;

    /**
     * 数据商品标签
     */
    @ApiModelProperty(value = "数据商品标签")
    private String dataLabel;

    /**
     * 数据商品图片
     */
    @ApiModelProperty(value = "数据商品图片")
    private String dataPicture;

    /**
     * 数据商品价格
     */
    @ApiModelProperty(value = "数据商品价格")
    private String dataPrice;

    /**
     * 价格类型
     */
    @ApiModelProperty(value = "价格类型")
    private String priceType;

    /**
     * 年(元)
     */
    @ApiModelProperty(value = "年(元)")
    private BigDecimal yearType;

    /**
     * 季(元)
     */
    @ApiModelProperty(value = "季(元)")
    private BigDecimal seasonType;

    /**
     * 月(元)
     */
    @ApiModelProperty(value = "月(元)")
    private BigDecimal monthType;

    /**
     * 次(元)
     */
    @ApiModelProperty(value = "次(元)")
    private BigDecimal secondType;



    public Long getDataGoodsId() {
        return dataGoodsId;
    }

    public void setDataGoodsId(Long dataGoodsId) {
        this.dataGoodsId = dataGoodsId;
    }

    public Long getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(Long categoryId) {
        this.categoryId = categoryId;
    }

    public String getDataName() {
        return dataName;
    }

    public void setDataName(String dataName) {
        this.dataName = dataName;
    }

    public String getCategoryName() {
        return categoryName;
    }

    public void setCategoryName(String categoryName) {
        this.categoryName = categoryName;
    }

    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public String getDataLabel() {
        return dataLabel;
    }

    public void setDataLabel(String dataLabel) {
        this.dataLabel = dataLabel;
    }

    public String getDataPicture() {
        return dataPicture;
    }

    public void setDataPicture(String dataPicture) {
        this.dataPicture = dataPicture;
    }

    public String getDataPrice() {
        return dataPrice;
    }

    public void setDataPrice(String dataPrice) {
        this.dataPrice = dataPrice;
    }

    public String getPriceType() {
        return priceType;
    }

    public void setPriceType(String priceType) {
        this.priceType = priceType;
    }

    public BigDecimal getYearType() {
        return yearType;
    }

    public void setYearType(BigDecimal yearType) {
        this.yearType = yearType;
    }

    public BigDecimal getSeasonType() {
        return seasonType;
    }

    public void setSeasonType(BigDecimal seasonType) {
        this.seasonType = seasonType;
    }

    public BigDecimal getMonthType() {
        return monthType;
    }

    public void setMonthType(BigDecimal monthType) {
        this.monthType = monthType;
    }

    public BigDecimal getSecondType() {
        return secondType;
    }

    public void setSecondType(BigDecimal secondType) {
        this.secondType = secondType;
    }

}
