package com.jz.dm.mall.moduls.controller.log;

import com.jz.common.bean.PageInfoResponse;
import com.jz.dm.mall.moduls.entity.PlatformLog;
import com.jz.common.utils.Result;
import com.jz.dm.mall.moduls.controller.log.bean.LogInfoQueryReq;
import com.jz.dm.mall.moduls.service.LogInfoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Mono;

import javax.servlet.http.HttpServletRequest;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.mall.moduls.controller.log
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: LogInfoController
 * @USER: key
 * @DATE: 2020-12-3
 * @DAY_NAME_SHORT: 周四
 * @Description:
 **/
@RestController
@RequestMapping("/logInfo")
@Api(tags = "日志信息controller")
public class LogInfoController {

    @Autowired
    private LogInfoService logInfoService;

    /**
     * @Description: 获取商城用户日志信息列表
     * @Author: Mr.zhang
     * @Date: 2020-12-2
     */
    @PostMapping("/getMallLogInfo")
    @ApiOperation(value = "获取商城用户日志信息列表")
    public PageInfoResponse<PlatformLog> getLogInfo(@RequestBody @Validated LogInfoQueryReq req, HttpServletRequest request) {
        return logInfoService.getMallUserLogInfo(req,request);
    }

    /**
     * @Description: 获取商城用户日志信息详情
     * @Author: Mr.zhang
     * @Date: 2020-12-2
     */
    @GetMapping("/getMallLogDetail/{id}")
    @ApiOperation(value = "获取商城用户日志信息详情")
    public Result getLogInfoDetail(@PathVariable(value = "id") Long platformLogId) {
        return logInfoService.getMallUserLogDetail(platformLogId);
    }
}
