package com.jz.dm.mall.moduls.controller.order.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

/**
 * api商品(DataGoodsApiDto)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@ApiModel
public class DataGoodsApiDto implements Serializable {
    private static final long serialVersionUID = -14346819849726413L;
    /**
     * api商品id
     */
    @ApiModelProperty(value = "api商品id")
    private Long goodsApi;
    /**
     * 数据id
     */
    @ApiModelProperty(value = "数据id")
    private Long dataGoodsId;
    /**
     * api服务名称
     */
    @ApiModelProperty(value = "api服务名称")
    private String apiName;
    /**
     * 请求类型（方式）
     */
    @ApiModelProperty(value = "请求类型（方式）")
    private String requestType;
    /**
     * api接口地址
     */
    @ApiModelProperty(value = "api接口地址")
    private String apiUrl;
    /**
     * api接口方法
     */
    @ApiModelProperty(value = "api接口方法")
    private String apiMethod;
    /**
     * api请求协议：http，https
     */
    @ApiModelProperty(value = "api请求协议：http，https")
    private String apiProtocl;
    /**
     * api返回数据样例
     */
    @ApiModelProperty(value = "api返回数据样例")
    private String returnDataExample;
    /**
     * api请求样例
     */
    @ApiModelProperty(value = "api请求样例")
    private String requestExample;
    /**
     * 返回类型
     */
    @ApiModelProperty(value = "返回类型")
    private String returnType;
    /**
     * apikey
     */
    @ApiModelProperty(value = "apikey")
    private String apiKey;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date creTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String crePerson;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String uptPerson;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date uptTime;

    /**
     * 授权码token
     */
    @ApiModelProperty(value = "授权码token")
    private String requestToken;

    /**
     * 接口参数信息
     */
    @ApiModelProperty(value = "接口参数信息")
    private List<DataGoodsApiParamsDto> apiParamsDto;

    public Long getGoodsApi() {
        return goodsApi;
    }

    public void setGoodsApi(Long goodsApi) {
        this.goodsApi = goodsApi;
    }

    public Long getDataGoodsId() {
        return dataGoodsId;
    }

    public void setDataGoodsId(Long dataGoodsId) {
        this.dataGoodsId = dataGoodsId;
    }

    public String getApiName() {
        return apiName;
    }

    public void setApiName(String apiName) {
        this.apiName = apiName;
    }

    public String getRequestType() {
        return requestType;
    }

    public void setRequestType(String requestType) {
        this.requestType = requestType;
    }

    public String getApiUrl() {
        return apiUrl;
    }

    public void setApiUrl(String apiUrl) {
        this.apiUrl = apiUrl;
    }

    public String getApiMethod() {
        return apiMethod;
    }

    public void setApiMethod(String apiMethod) {
        this.apiMethod = apiMethod;
    }

    public String getApiProtocl() {
        return apiProtocl;
    }

    public void setApiProtocl(String apiProtocl) {
        this.apiProtocl = apiProtocl;
    }

    public String getReturnDataExample() {
        return returnDataExample;
    }

    public void setReturnDataExample(String returnDataExample) {
        this.returnDataExample = returnDataExample;
    }

    public String getRequestExample() {
        return requestExample;
    }

    public void setRequestExample(String requestExample) {
        this.requestExample = requestExample;
    }

    public String getReturnType() {
        return returnType;
    }

    public void setReturnType(String returnType) {
        this.returnType = returnType;
    }

    public String getApiKey() {
        return apiKey;
    }

    public void setApiKey(String apiKey) {
        this.apiKey = apiKey;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public String getUptPerson() {
        return uptPerson;
    }

    public void setUptPerson(String uptPerson) {
        this.uptPerson = uptPerson;
    }

    public Date getUptTime() {
        return uptTime;
    }

    public void setUptTime(Date uptTime) {
        this.uptTime = uptTime;
    }

    public String getRequestToken() {
        return requestToken;
    }

    public void setRequestToken(String requestToken) {
        this.requestToken = requestToken;
    }

    public List<DataGoodsApiParamsDto> getApiParamsDto() {
        return apiParamsDto;
    }

    public void setApiParamsDto(List<DataGoodsApiParamsDto> apiParamsDto) {
        this.apiParamsDto = apiParamsDto;
    }
}