package com.jz.dm.mall.moduls.controller.order.bean;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * api商品参数配置(TDataGoodsApiParams)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@ApiModel
public class DataGoodsApiParamsDto implements Serializable {
    private static final long serialVersionUID = 944366688061324185L;
    /**
     * api参数id
     */
    @ApiModelProperty(value = "api参数id")
    private Long apiParamsId;
    /**
     * api商品id
     */
    @ApiModelProperty(value = "api商品id")
    private Long goodsApi;
    /**
     * 参数分类：01公共参数，02请求参数，03响应参数，04请求头参数，05状态码参数
     */
    @ApiModelProperty(value = "参数分类：01公共参数，02请求参数，03响应参数，04请求头参数，05状态码参数")
    private String paramsDiff;
    /**
     * 参数名称
     */
    @ApiModelProperty(value = "参数名称")
    private String paramsName;
    /**
     * 参数类型
     */
    @ApiModelProperty(value = "参数类型")
    private String paramsType;
    /**
     * 参数描述
     */
    @ApiModelProperty(value = "参数描述")
    private String paramsDesc;
    /**
     * 默认值
     */
    @ApiModelProperty(value = "默认值")
    private String defaultValue;
    /**
     * 是否必选：Y是，N否
     */
    @ApiModelProperty(value = "是否必选：Y是，N否")
    private String ifRequird;
    /*
     * 参数分类：名称
     * */
    @ApiModelProperty(value = "参数分类名称")
    private String paramsDiffName;

    public Long getGoodsApi() {
        return goodsApi;
    }

    public void setGoodsApi(Long goodsApi) {
        this.goodsApi = goodsApi;
    }

    public String getParamsDiff() {
        return paramsDiff;
    }

    public void setParamsDiff(String paramsDiff) {
        this.paramsDiff = paramsDiff;
    }

    public String getParamsName() {
        return paramsName;
    }

    public void setParamsName(String paramsName) {
        this.paramsName = paramsName;
    }

    public String getParamsType() {
        return paramsType;
    }

    public void setParamsType(String paramsType) {
        this.paramsType = paramsType;
    }

    public String getParamsDesc() {
        return paramsDesc;
    }

    public void setParamsDesc(String paramsDesc) {
        this.paramsDesc = paramsDesc;
    }

    public String getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(String defaultValue) {
        this.defaultValue = defaultValue;
    }

    public String getIfRequird() {
        return ifRequird;
    }

    public void setIfRequird(String ifRequird) {
        this.ifRequird = ifRequird;
    }

    public String getParamsDiffName() {
        return paramsDiffName;
    }

    public void setParamsDiffName(String paramsDiffName) {
        this.paramsDiffName = paramsDiffName;
    }

    public Long getApiParamsId() {
        return apiParamsId;
    }

    public void setApiParamsId(Long apiParamsId) {
        this.apiParamsId = apiParamsId;
    }
}