package com.jz.dm.mall.moduls.controller.pay;

import com.jz.common.utils.Result;
import com.jz.dm.mall.moduls.controller.pay.dto.PayDto;
import com.jz.dm.mall.moduls.service.PayService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @ClassName: 支付controller
 * @Author: Carl
 * @Date: 2020/12/31
 * @Version:
 */
@RestController
@RequestMapping("/pay")
@Api(tags = "支付controller")
public class PayController {

    @Autowired
    private PayService payService;

    @PostMapping("/payment")
    @ApiOperation(value = "支付功能")
    public Result payController(@RequestBody PayDto payDto) throws Exception {
        // payDto是请求
        Result result = new Result();
        try{
            result = payService.goodsPay(payDto);
        }catch (Exception e) {
            e.printStackTrace();
            result = new Result(false, "支付失败！");
        }
        return result;
    }
}
