package com.jz.dm.mall.moduls.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 数据商品(TDataGoods)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:30
 */
@TableName("t_data_goods")
@ApiModel
public class DataGoods implements Serializable {
    private static final long serialVersionUID = 938517475031285541L;
    /**
     * 数据商品id
     */
    private Long dataGoodsId;
    /**
     * 商品分类id（行业）
     */
    private Long categoryId;
    /**
     * 数据商户id
     */
    private Long userId;
    /**
     * 数据商品名称
     */
    private String dataName;
    /**
     * 数据类型：01api，02数据包
     */
    private String dataType;
    /**
     * 数据商品标签
     */
    private String dataLabel;
    /**
     * 数据商品图片
     */
    private String dataPicture;
    /**
     * 数据商品价格
     */
    private BigDecimal dataPrice;
    /**
     * 优惠价格
     */
    private BigDecimal discountPrice;
    /**
     * 价格类型：01免费，02收费
     */
    private String priceType;
    /**
     * 商品规格
     */
    private String goodsStandards;
    /**
     * 数据状态：01预售，02在售中，03下架，04上架
     */
    private String dataStatus;
    /**
     * 审核状态：01待审核，02已审核，03未通过
     */
    private String auditStatus;
    /**
     * 清洗规则（脱敏校验）
     */
    private String cleanRule;
    /**
     * 驳回原因
     */
    private String rejectReason;
    /**
     * 审核人
     */
    private String auditPerson;
    /**
     * 审核时间
     */
    private Date auditTime;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 更新时间
     */
    private Date uptTime;
    /**
     * 更新人
     */
    private String uptPerson;
    /**
     * 删除标识
     */
    private String delFlag;
    /**
     * 年（元）
     */
    private BigDecimal yearType;
    /**
     * 季（元）
     */
    private BigDecimal seasonType;
    /**
     * 月（元）
     */
    private BigDecimal monthType;
    /**
     * 次（元）
     */
    private BigDecimal secondType;


    public Long getDataGoodsId() {
        return dataGoodsId;
    }

    public void setDataGoodsId(Long dataGoodsId) {
        this.dataGoodsId = dataGoodsId;
    }

    public Long getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(Long categoryId) {
        this.categoryId = categoryId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public String getDataName() {
        return dataName;
    }

    public void setDataName(String dataName) {
        this.dataName = dataName;
    }

    public String getDataType() {
        return dataType;
    }

    public void setDataType(String dataType) {
        this.dataType = dataType;
    }

    public String getDataLabel() {
        return dataLabel;
    }

    public void setDataLabel(String dataLabel) {
        this.dataLabel = dataLabel;
    }

    public String getDataPicture() {
        return dataPicture;
    }

    public void setDataPicture(String dataPicture) {
        this.dataPicture = dataPicture;
    }

    public BigDecimal getDataPrice() {
        return dataPrice;
    }

    public void setDataPrice(BigDecimal dataPrice) {
        this.dataPrice = dataPrice;
    }

    public BigDecimal getDiscountPrice() {
        return discountPrice;
    }

    public void setDiscountPrice(BigDecimal discountPrice) {
        this.discountPrice = discountPrice;
    }

    public String getPriceType() {
        return priceType;
    }

    public void setPriceType(String priceType) {
        this.priceType = priceType;
    }

    public String getGoodsStandards() {
        return goodsStandards;
    }

    public void setGoodsStandards(String goodsStandards) {
        this.goodsStandards = goodsStandards;
    }

    public String getDataStatus() {
        return dataStatus;
    }

    public void setDataStatus(String dataStatus) {
        this.dataStatus = dataStatus;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getCleanRule() {
        return cleanRule;
    }

    public void setCleanRule(String cleanRule) {
        this.cleanRule = cleanRule;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getAuditPerson() {
        return auditPerson;
    }

    public void setAuditPerson(String auditPerson) {
        this.auditPerson = auditPerson;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public Date getUptTime() {
        return uptTime;
    }

    public void setUptTime(Date uptTime) {
        this.uptTime = uptTime;
    }

    public String getUptPerson() {
        return uptPerson;
    }

    public void setUptPerson(String uptPerson) {
        this.uptPerson = uptPerson;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public BigDecimal getYearType() {
        return yearType;
    }

    public void setYearType(BigDecimal yearType) {
        this.yearType = yearType;
    }

    public BigDecimal getSeasonType() {
        return seasonType;
    }

    public void setSeasonType(BigDecimal seasonType) {
        this.seasonType = seasonType;
    }

    public BigDecimal getMonthType() {
        return monthType;
    }

    public void setMonthType(BigDecimal monthType) {
        this.monthType = monthType;
    }

    public BigDecimal getSecondType() {
        return secondType;
    }

    public void setSecondType(BigDecimal secondType) {
        this.secondType = secondType;
    }

}