package com.jz.dm.mall.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 商城企业客户资产(TFinanceCustomerAssets)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:38
 */
@TableName("t_finance_customer_assets")
@ApiModel
public class FinanceCustomerAssets implements Serializable {
    private static final long serialVersionUID = -86484762300825431L;
    /**
     * 资产id
     */
    @TableId(value = "assets_id",type = IdType.AUTO)
    @ApiModelProperty(value = "资产id")
    private Long assetsId;
    /**
     * 企业id
     */
    @ApiModelProperty(value = "企业id")
    private Long departmentId;
    /**
     * 可用金额
     */
    @ApiModelProperty(value = "可用金额")
    private BigDecimal useMoney;
    /**
     * 冻结金额
     */
    @ApiModelProperty(value = "冻结金额")
    private BigDecimal frozenMoney;
    /**
     * 总金额
     */
    @ApiModelProperty(value = "总金额")
    private BigDecimal totalMoney;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date creTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String crePerson;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date uptTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String uptPerson;
    /**
     * 删除标识
     */
    @ApiModelProperty(value = "删除标识")
    private String delFlag;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;


    public Long getAssetsId() {
        return assetsId;
    }

    public void setAssetsId(Long assetsId) {
        this.assetsId = assetsId;
    }

    public Long getDepartmentId() {
        return departmentId;
    }

    public void setDepartmentId(Long departmentId) {
        this.departmentId = departmentId;
    }

    public BigDecimal getUseMoney() {
        return useMoney;
    }

    public void setUseMoney(BigDecimal useMoney) {
        this.useMoney = useMoney;
    }

    public BigDecimal getFrozenMoney() {
        return frozenMoney;
    }

    public void setFrozenMoney(BigDecimal frozenMoney) {
        this.frozenMoney = frozenMoney;
    }

    public BigDecimal getTotalMoney() {
        return totalMoney;
    }

    public void setTotalMoney(BigDecimal totalMoney) {
        this.totalMoney = totalMoney;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public Date getUptTime() {
        return uptTime;
    }

    public void setUptTime(Date uptTime) {
        this.uptTime = uptTime;
    }

    public String getUptPerson() {
        return uptPerson;
    }

    public void setUptPerson(String uptPerson) {
        this.uptPerson = uptPerson;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
}