package com.jz.dm.mall.moduls.mapper;

import com.jz.common.base.BaseMapper;
import com.jz.dm.mall.moduls.controller.customer.bean.CustomerDto;
import com.jz.dm.mall.moduls.entity.MallCustomer;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;

import java.util.Map;

/**
 * 商城用户(TMallCustomer)表数据库访问层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:39
 */
public interface MallCustomerDao extends BaseMapper<MallCustomer> {
    /**
     * 根据账号查询用户信息
     * @param username
     * @return
     */
    CustomerDto selectByAccount(String username);


    /**
     * 根据手机号查询用户信息
     * @param username
     * @return
     */
    CustomerDto selectByPhone(String username);

    /**
     * 根据手机号查询是否已注册
     * @param telephone
     * @return
     */
    MallCustomer selectByPhoneExist(String telephone);


    /**
     * 添加用户
     * @param mallCustomer
     */
    @Insert("INSERT into t_mall_customer(customer_account, customer_phone, password, register_time, cre_time) VALUES (#{customerAccount},#{customerPhone}, #{password},#{registerTime}, #{creTime})")
    void saveCustomer(MallCustomer mallCustomer);


    /**
     * 根据ID查询用户信息
     * @param customerId
     * @return
     */
    MallCustomer findById(@Param("customerId") Long customerId);


    /**
     * 修改密码
     * @param map
     */
    void updatePassword(Map map);

}