package com.jz.dm.mall.moduls.mapper;

import com.jz.common.base.BaseMapper;
import com.jz.dm.mall.moduls.controller.order.bean.DataGoodsApiDto;
import com.jz.dm.mall.moduls.controller.order.bean.DataGoodsApiParamsDto;
import com.jz.dm.mall.moduls.controller.order.bean.OrderDto;
import com.jz.dm.mall.moduls.entity.Order;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * 订单表(TOrder)表数据库访问层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:40
 */
public interface OrderDao extends BaseMapper<Order> {


    List<OrderDto> findList(Map<String, Object> param) throws Exception;

    OrderDto getOrderDetail(@Param("orderId") String orderId) throws Exception;

    List<DataGoodsApiDto> getApiInterfaceDetail(Map params) throws Exception;

    List<DataGoodsApiDto> getApiInterface(Map params) throws Exception;

    List<DataGoodsApiParamsDto> getApiParamsInfo(@Param("goodsApi") Long goodsApi);

    void addOrder(Order order);
}