package com.jz.dm.mall.moduls.service;

import com.jz.common.entity.Department;
import com.jz.dm.mall.moduls.controller.company.bean.CompanyAddReq;
import com.jz.common.utils.Result;
import com.jz.dm.mall.moduls.controller.company.bean.CompanyUpdateReq;

import javax.servlet.http.HttpServletRequest;

/**
 * @author ZC
 * @PACKAGE_NAME: com.jz.dm.mall.moduls.service
 * @PROJECT_NAME: jz-dm-parent
 * @NAME: CompanyAuthService
 * @USER: key
 * @DATE: 2020-12-2/16:34
 * @DAY_NAME_SHORT: 周三
 * @Description:
 **/
public interface CompanyAuthService {
    /**
     * 添加企业认证
     * @param req
     * @param request
     * @return
     */
    Result addCompanyData(CompanyAddReq req, HttpServletRequest request);

    /**
     * 查询企业认证详情
     * @param request
     * @param type
     * @return
     */
    Result selectCompany(String type,HttpServletRequest request);


    /**
     * 更新企业信息
     * @param request
     * @param req
     * @return
     */
    Result updateCompanyInfo(CompanyUpdateReq req,HttpServletRequest request);

    /**
     * 校验当前用户是否已经企业认证
     * @param request
     * @return
     */
    Result checkCompanyInfo(HttpServletRequest request);

}
