package com.jz.dm.mall.moduls.service.impl;


import com.jz.dm.mall.moduls.controller.goods.bean.dto.MallHotRecommendGoodsDto;
import com.jz.dm.mall.moduls.mapper.MallHotRecommendGoodsDao;
import com.jz.dm.mall.moduls.service.MallHotRecommendGoodsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.math.MathContext;
import java.text.DecimalFormat;
import java.util.List;

/**
 * 热门推荐商品(TMallHotRecommendGoods)表服务实现类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:40
 */
@Service("mallHotRecommendGoodsService")
public class MallHotRecommendGoodsServiceImpl implements MallHotRecommendGoodsService {
    @Autowired
    private MallHotRecommendGoodsDao tMallHotRecommendGoodsDao;

    /**
     * 查询热门api数据
     *
     * @return
     */
    @Override
    public List<MallHotRecommendGoodsDto> selectByPopularApi() {
        List<MallHotRecommendGoodsDto> popularApiList = tMallHotRecommendGoodsDao.selectByPopularApi();
        for (MallHotRecommendGoodsDto goodsDto : popularApiList) {
            goodsDto.getDataPrice().setScale(3);
        }
        return popularApiList;
    }
}