package com.jz.manage.intercept;

import java.lang.annotation.*;

/**
 * ClassName: SysOperateLog <br/>
 * Function: AOP日志记录，自定义注解 <br/>
 * date: 2020年6月7日 上午9:29:01 <br/>
 * @author boss
 *
 * @Target({ ElementType.METHOD, ElementType.TYPE }) 表示该注解可以用在方法上或类上
 * @Retention(RetentionPolicy.RUNTIME)表示运行时使用
 * @Documented用于生成doc文档
*/
@Target({ElementType.PARAMETER, ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
@Documented
public @interface SysOperaterLog {

    String module() default "";  //功能模块

    String remark() default ""; // 操作备注

    String operateType() default ""; // 操作类型：Add/Update/Delete/Search/Login等
}
