package com.jz.manage.moduls.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jz.common.entity.User;
import com.jz.common.utils.Result;
import com.jz.manage.moduls.service.TestUserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/*
 *
 * 测试样例
 * */
@RestController
@RequestMapping("/user")
@Api(tags = "测试样例API")
public class TestUserController extends BaseController {

    @Autowired
    private TestUserService testUserService;

    @PostMapping("/getTest")
    public List<Map> getTest() {
        System.out.print("117576575" + testUserService.getTest().toString());
        return testUserService.getTest();
    }

    @GetMapping(value = "/events")
    @ApiOperation(value = "测试样例列表（分页查询）", notes = "事件列表（分页查询）")
    public Result<IPage<User>> queryPageList(User event, HttpServletRequest req) throws Exception {
        Result<IPage<User>> result = new Result<IPage<User>>();
        IPage<User> pageList = testUserService.queryPage(new Page<User>(1, 2), event);
        result.setSuccess(true);
        result.setData(pageList);
        return result;
    }

    @GetMapping(value = "/queryPageListSff")
    @ApiOperation(value = "测试样例列表（分页查询）", notes = "事件列表（分页查询）")
    public Result<IPage<Map>> queryPageListSff(User event, HttpServletRequest req) throws Exception {
        Result<IPage<Map>> result = new Result<IPage<Map>>();
        IPage<Map> pageList = testUserService.queryListPage(new Page<Map>(1, 2), event);
        result.setSuccess(true);
        result.setData(pageList);
        return result;
    }
}
