package com.jz.manage.moduls.controller.finance.platForm;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 平台利润中心--充值管理--分页列表返回参数对象
 *
 * @author Bellamy
 * @since 2020-12-05 10:41:43
 */
@ApiModel(value = "充值管理--分页列表返回参数对象", description = "分页列表返回参数对象")
public class BalanceListDto {

    /**
     * 企业名
     */
    @ApiModelProperty(value = "企业名")
    private String departmentName;
    /**
     * 充值描述
     */
    @ApiModelProperty(value = "充值描述")
    private String remark;

    /**
     * 充值金额
     */
    @ApiModelProperty(value = "充值金额")
    private BigDecimal balanceMoney;

    /**
     * 充值时间
     */
    @ApiModelProperty(value = "充值时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date balanceTime;

    /**
     * 充值状态：01待审核，02审核通过，03未通过
     */
    @ApiModelProperty(value = "充值状态")
    private String auditStatus;
    /**
     * 提现id
     */
    @ApiModelProperty(value = "提现id")
    private Long customerBalanceId;


    public String getDepartmentName() {
        return departmentName;
    }

    public void setDepartmentName(String departmentName) {
        this.departmentName = departmentName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public BigDecimal getBalanceMoney() {
        return balanceMoney;
    }

    public void setBalanceMoney(BigDecimal balanceMoney) {
        this.balanceMoney = balanceMoney;
    }

    public Date getBalanceTime() {
        return balanceTime;
    }

    public void setBalanceTime(Date balanceTime) {
        this.balanceTime = balanceTime;
    }

    public Long getCustomerBalanceId() {
        return customerBalanceId;
    }

    public void setCustomerBalanceId(Long customerBalanceId) {
        this.customerBalanceId = customerBalanceId;
    }
}