package com.jz.manage.moduls.controller.finance.platForm;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

/**
 * 平台利润中心--提现管理--分页列表返回参数对象
 *
 * @author Bellamy
 * @since 2020-12-05 10:41:43
 */
@ApiModel(value = "提现管理--分页列表返回参数对象", description = "分页列表返回参数对象")
public class CashOutListDto {

    /**
     * 企业名
     */
    @ApiModelProperty(value = "企业名")
    private String departmentName;
    /**
     * 提现描述
     */
    @ApiModelProperty(value = "提现描述")
    private String remark;

    /**
     * 提现金额
     */
    @ApiModelProperty(value = "提现金额")
    private BigDecimal cashOutMoney;

    /**
     * 提现时间
     */
    @ApiModelProperty(value = "提现时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date casOutTime;

    /**
     * 提现状态：01待审核，02审核通过，03未通过
     */
    @ApiModelProperty(value = "提现状态")
    private String auditStatus;
    /**
     * 提现id
     */
    @ApiModelProperty(value = "提现id")
    private Long cashOutId;


    public String getDepartmentName() {
        return departmentName;
    }

    public void setDepartmentName(String departmentName) {
        this.departmentName = departmentName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public Date getCasOutTime() {
        return casOutTime;
    }

    public void setCasOutTime(Date casOutTime) {
        this.casOutTime = casOutTime;
    }

    public BigDecimal getCashOutMoney() {
        return cashOutMoney;
    }

    public void setCashOutMoney(BigDecimal cashOutMoney) {
        this.cashOutMoney = cashOutMoney;
    }

    public Long getCashOutId() {
        return cashOutId;
    }

    public void setCashOutId(Long cashOutId) {
        this.cashOutId = cashOutId;
    }
}