package com.jz.manage.moduls.controller.goods;


import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.controller.BaseController;
import com.jz.manage.moduls.service.DataGoodsApiService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * api商品(TDataGoodsApi)表控制层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@RestController
@RequestMapping("dataGoodsApi")
@Api(tags = "平台--数据api-controller")
public class DataGoodsApiController extends BaseController {
    /**
     * 服务对象
     */
    @Autowired
    private DataGoodsApiService tDataGoodsApiService;

    /**
     * 根据主键查询商品详情-api
     * @param id
     * @return
     */
    @GetMapping("/getDataDetails/{id}")
    @ApiOperation(value = "点击商品查看商品详情", notes = "api商品")
    public Result findById(@PathVariable(value = "id") Long id) throws Exception{
        if (id != null) {
            Result result = tDataGoodsApiService.selectById(id);
            result.getData();
            result.getCode();
            result.getMessage();
            return result;
        }
        return new Result<>(false, "查询商品详情失败！", StatusCode.ERROR);
    }


}