package com.jz.manage.moduls.controller.goods.bean.request;

import com.jz.manage.moduls.entity.DataGoodsApiParams;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.Getter;
import lombok.Setter;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @ClassName:
 * @Author: Carl
 * @Date: 2020/12/29
 * @Version:
 */
@Data
@ApiModel(value = "自营数据--api上传参数对象", description = "api上传参数对象")
public class DataApiUpReq implements Serializable {

    /**
     * api表
     */

    @ApiModelProperty(value = "请求类型")
    private String requestType;

    @ApiModelProperty(value = "接口地址")
    private String apiUrl;

    @ApiModelProperty(value = "api请求协议 HTTP/HTTPS")
    @NotNull()
    private String apiProtocl;

    @ApiModelProperty(value = "api返回数据样例")
    private String returnDataExample;

    @ApiModelProperty(value = "返回类型 json/flow")
    private String returnType;

    @ApiModelProperty(value = "加密方式  MD5/RSA")
    private String encryMode;

    @ApiModelProperty(value = "功能")
    private String apiFunction;


    @ApiModelProperty(value = "创建人", hidden = true)
    private String crePerson;

    @ApiModelProperty(value = "价格类型")
    private String priceType;

    @ApiModelProperty(value = "api类型 01:api 02: 数据包")
    private String apiType;

    @ApiModelProperty(value = "接口描述",required = false)
    private String apiDesc;

    @ApiModelProperty(value = "目标地址",required = false)
    private String targetUrl;

    /**
     * goods表
     */
    @ApiModelProperty(value = "数据名称")
    private String dataName;

    @ApiModelProperty(value = "商品分类")
    private Long categoryId;

    @ApiModelProperty(value = "数据描述")
    private String dataDesc;

    @ApiModelProperty(value = "商品图片")
    private String dataPicture;


    @ApiModelProperty(value = "唯一数据商品标识")
    private String apiOpenId;

    @ApiModelProperty(value = "审核人" , hidden = true)
    private String auditPerson;

    @ApiModelProperty(value = "年（元）")
    private BigDecimal yearType;

    @ApiModelProperty(value = "季（元）")
    private BigDecimal seasonType;

    @ApiModelProperty(value = "月（元）")
    private BigDecimal monthType;

    @ApiModelProperty(value = "次（元）")
    private BigDecimal secondType;

    /**
     * apiParam
     */
    @ApiModelProperty(value = "请求头")
    private List<DataGoodsApiParams> reqHeaders;

    @ApiModelProperty(value = "请求参数")
    private List<DataGoodsApiParams> requestParam;

    @ApiModelProperty(value = "响应参数")
    private List<DataGoodsApiParams> responseParam;

    @ApiModelProperty(value = "固定参数")
    private List<DataGoodsApiParams> inboxParam;

    @ApiModelProperty(value = "响应状态码参数")
    public List<DataGoodsApiParams> respCode;


    /**
     * 接口需要的参数
     */
    @ApiModelProperty(value = "接入类型:对应字典表key",required = true)
    @NotNull(message = "接入类型不能为空")
    public String joinType;
}
