package com.jz.manage.moduls.controller.log;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.jz.common.bean.PageInfoResponse;
import com.jz.manage.moduls.entity.PlatformLog;
import com.jz.common.utils.Result;
import com.jz.manage.moduls.controller.BaseController;
import com.jz.manage.moduls.controller.log.bean.ManageLogInfoQueryReq;
import com.jz.manage.moduls.service.PlatformLogService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Mono;

/**
 * 日志管理(TPlatformLog)表控制层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:43
 */
@RestController
@RequestMapping("platformLog")
@Api(tags = "平台日志Controller")
public class PlatformLogController extends BaseController {
    /**
     * 服务对象
     */
    @Autowired
    private PlatformLogService tPlatformLogService;

    /**
     * @Description: 后台用户日志信息列表
     * @Author: Mr.zhang
     * @Date: 2020-12-2
     */
    @PostMapping("/listManageLogInfo")
    @ApiOperation(value = "后台用户日志信息列表")
    public Result<IPage<PlatformLog>> getLogInfo(@RequestBody @Validated ManageLogInfoQueryReq req) {
        return tPlatformLogService.listManageUserLogInfo(req);
    }

    /**
     * @Description: 获取用户日志信息详情
     * @Author: Mr.zhang
     * @Date: 2020-12-2
     */
    @GetMapping("/getLogDetail/{id}")
    @ApiOperation(value = "获取用id户日志信息详情")
    public Result getLogInfoDetail(@PathVariable(value = "id")Long platformLogId) {
        return tPlatformLogService.getMallUserLogDetail(platformLogId);
    }
}