package com.jz.manage.moduls.controller.sys;

import com.jz.common.constant.RedisMessageConstant;
import com.jz.common.entity.SysUser;
import com.jz.common.utils.Result;
import com.jz.common.utils.SessionUtils;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.controller.BaseController;
import com.jz.manage.moduls.controller.sys.bean.req.LoginRequest;
import com.jz.manage.moduls.service.SysUserService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.security.auth.Subject;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Map;

@RestController
@RequestMapping("/sys")
@Api(tags = "用户登录api")
public class LoginController extends BaseController {

    @Autowired
    private SysUserService sysUserService;

    @Autowired
    private RedisTemplate redisTemplate;
    /**
     * 登录功能
     * @return
     */
    @PostMapping(value = "login")
    public Result login(@RequestBody LoginRequest user, HttpServletRequest request) {
        if (!StringUtils.isEmpty(user)) {
            String username = user.getUsername();
            String password = user.getPassword();
            // 手机
            String ph = "^[1][34578]\\d{9}$";
            // 如果是手机验证
            if (username.matches(ph)) {
                SysUser sysUser = sysUserService.selectByPhone(username, request);
                if (sysUser != null) {
                    if (sysUser.getTelephone().equals(username) && sysUser.getPassword().equals(password)) {
                        return new Result<>(true, "登录成功！", StatusCode.OK);
                    }
                    return new Result<>(false, "用户名或密码错误！", StatusCode.ERROR);
                }
            }
            SysUser sysUser = sysUserService.selectByUsername(username, request);
            if (sysUser != null) {
                if (sysUser.getAccount().equals(username) && sysUser.getPassword().equals(password)) {
                    return new Result<>(true, "登录成功！", StatusCode.OK);
                }
            }
            return new Result<>(false, "用户名或密码错误！", StatusCode.ERROR);
        }
        return new Result(false, "用户名密码不能为空！", StatusCode.ERROR);
    }


//    /**
//     * 手机号码校验
//     * @param paramMap
//     * @param res
//     * @return
//     */
//    @PostMapping(value = "/check")
//    public Result loginCheck(@RequestBody Map<String, String> paramMap, HttpServletResponse res) {
//        // 获取手机号码
//        String telephone = paramMap.get("telephone");
//        String key = RedisMessageConstant.SENDTYPE_LOGIN + "_" + telephone;
//        // 获取redis中key对应的值
//        String codeInRedis = (String) redisTemplate.opsForValue().get(key);
//        if (StringUtils.isEmpty(codeInRedis)) {
//            return new Result(false, "请重新获取验证码!", StatusCode.ERROR);
//        }
//        // 判断验证码是否一致
//        if (!codeInRedis.equals(paramMap.get("validateCode"))) {
//            return new Result(false, "验证码不正确！", StatusCode.ERROR);
//        }
//        // 删除redis的验证码
//        redisTemplate.delete(key);
//
//        return new Result(true, "验证码正确！", StatusCode.OK);
//    }



    /*@ApiOperation("登录接口")
    @RequestMapping(value = "/login", method = RequestMethod.POST)
    public Result<JSONObject> login(@RequestBody SysUser sysUser, HttpServletRequest request) throws Exception {
        Result<JSONObject> result = new Result<>();
        String account = sysUser.getAccount();
        String password = sysUser.getPassword();

        Subject subject = SecurityUtils.getSubject();  //获取当前用户
        //将用户输入的用户名写密码封装到一个UsernamePasswordToken对象中
        UsernamePasswordToken token = new UsernamePasswordToken(account, password);
        //用Subject对象执行登录方法，没有抛出任何异常说明登录成功
        try {
            //执行登录方法，如果没有异常，就OK
            //login()方法会调用 Realm类中执行认证逻辑的方法，
            //并将这个参数传递给doGetAuthenticationInfo()方法
            subject.login(token);
            result.setSuccess(true);
            result.setCode(CommonConstant.SC_OK_200);
            result.setMessage("登录成功！");
            return result;
        } catch (UnknownAccountException e) {
            result.setSuccess(false);
            result.setCode(CommonConstant.SC_INTERNAL_SERVER_ERROR_500);
            result.setMessage("账号错误！");
            return result;
        } catch (IncorrectCredentialsException e) {
            result.setSuccess(false);
            result.setCode(CommonConstant.SC_INTERNAL_SERVER_ERROR_500);
            result.setMessage("密码错误！");
            return result;
        }
    }*/

}
