package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * api商品(DataGoodsApi)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@TableName("t_data_goods_api")
@ApiModel
@Data
public class DataGoodsApi implements Serializable {
    private static final long serialVersionUID = -14346819849726413L;
    /**
     * api商品id
     */
    @ApiModelProperty(value = "主健ID")
    @TableId(value = "id", type = IdType.AUTO)
    private Long goodsApi;
    /**
     * 数据id
     */
    private Long dataGoodsId;
    /**
     * api服务名称
     */
    private String apiName;
    /**
     * 请求类型（方式）
     */
    private String requestType;
    /**
     * api接口地址
     */
    private String apiUrl;
    /**
     * api接口方法
     */
    private String apiMethod;
    /**
     * api请求协议：http，https
     */
    private String apiProtocl;
    /**
     * api返回数据样例
     */
    private String returnDataExample;
    /**
     * api请求样例
     */
    private String requestExample;
    /**
     * 返回类型
     */
    private String returnType;
    /**
     * apikey
     */
    private String apiKey;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 更新人
     */
    private String uptPerson;
    /**
     * 更新时间
     */
    private Date uptTime;
    /**
     * 删除标识
     */
    private String delFlag;

    /**
     * 加密方式
     */
    private String encryMode;

    /**
     * 传输方式
     */
    private String transMode;

    /**
     * 版本号
     */
    private String versionNumber;




}