package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * api商品参数配置(TDataGoodsApiParams)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@TableName("t_data_goods_api_params")
@ApiModel
@Data
public class DataGoodsApiParams implements Serializable {
    private static final long serialVersionUID = 944366688061324185L;
    /**
     * api参数id
     */
    @ApiModelProperty("主健ID")
    @TableId(value = "id", type = IdType.AUTO)
    private Long apiParamsId;
    /**
     * api商品id
     */
    @ApiModelProperty(value = "api商品id")
    private Long goodsApi;
    /**
     * 参数分类：01公共参数，02请求参数，03响应参数，04请求头参数，05状态码参数
     */
    @ApiModelProperty(value = "参数分类")
    private String paramsDiff;
    /**
     * 参数名称
     */
    @ApiModelProperty(value = "参数名称")
    private String paramsName;
    /**
     * 参数类型
     */
    @ApiModelProperty(value = "参数类型")
    private String paramsType;
    /**
     * 参数描述
     */
    @ApiModelProperty(value = "参数描述")
    private String paramsDesc;
    /**
     * 默认值
     */
    @ApiModelProperty(value = "默认值")
    private String defaultValue;
    /**
     * 备注
     */
    @ApiModelProperty(value = "备注")
    private String remark;
    /**
     * 是否必选：Y是，N否
     */
    @ApiModelProperty(value = "是否必选")
    private String ifRequird;
    /**
     * 删除标识：Y是，N否
     */
    @ApiModelProperty(value = "删除标识")
    private String delFlag;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date creTime;

    @ApiModelProperty(value = "创建人")
    private String crePerson;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date uptTime;




}