package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.util.Date;

/**
 * 用户需求定制申请(Demand)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:34
 */
@TableName("t_demand")
@ApiModel
public class Demand implements Serializable {
    private static final long serialVersionUID = 119352065467540895L;
    /**
     * 需求id
     */
    private Long demandId;
    /**
     * 用户id
     */
    private Long customerId;
    /**
     * 商品分类id（行业）
     */
    private Long categoryId;
    /**
     * 需求名称
     */
    private String demandName;
    /**
     * 需求描述
     */
    private String demandDescribe;
    /**
     * 数据类型：01api，02数据包
     */
    private Long dataType;
    /**
     * 发布时间
     */
    private Date releaseTime;
    /**
     * 审核状态：01待审核，02已审核，03未通过
     */
    private String auditStatus;
    /**
     * 审核人
     */
    private String auditPerson;
    /**
     * 审核时间
     */
    private Date auditTime;
    /**
     * 驳回原因
     */
    private String rejectReason;
    /**
     * 购买方式
     */
    private String purchaseMethod;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 展示状态：01展示，02不展示
     */
    private String ifShow;
    /**
     * 删除标识：Y是，N否
     */
    private String delFlag;


    public Long getDemandId() {
        return demandId;
    }

    public void setDemandId(Long demandId) {
        this.demandId = demandId;
    }

    public Long getCustomerId() {
        return customerId;
    }

    public void setCustomerId(Long customerId) {
        this.customerId = customerId;
    }

    public Long getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(Long categoryId) {
        this.categoryId = categoryId;
    }

    public String getDemandName() {
        return demandName;
    }

    public void setDemandName(String demandName) {
        this.demandName = demandName;
    }

    public String getDemandDescribe() {
        return demandDescribe;
    }

    public void setDemandDescribe(String demandDescribe) {
        this.demandDescribe = demandDescribe;
    }

    public Long getDataType() {
        return dataType;
    }

    public void setDataType(Long dataType) {
        this.dataType = dataType;
    }

    public Date getReleaseTime() {
        return releaseTime;
    }

    public void setReleaseTime(Date releaseTime) {
        this.releaseTime = releaseTime;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getAuditPerson() {
        return auditPerson;
    }

    public void setAuditPerson(String auditPerson) {
        this.auditPerson = auditPerson;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getPurchaseMethod() {
        return purchaseMethod;
    }

    public void setPurchaseMethod(String purchaseMethod) {
        this.purchaseMethod = purchaseMethod;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getIfShow() {
        return ifShow;
    }

    public void setIfShow(String ifShow) {
        this.ifShow = ifShow;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

}