package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.util.Date;

/**
 * 企业(TDepartment)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:34
 */
@TableName("t_department")
@ApiModel
public class Department implements Serializable {
    private static final long serialVersionUID = -86955761674824098L;
    /**
     * 企业id
     */
    @TableId(value = "department_id",type = IdType.AUTO)
    private Long departmentId;
    /**
     * 企业名称
     */
    private String departmentName;
    /**
     * 法人代表
     */
    private String legalRepresentative;
    /**
     * 省份
     */
    private String province;
    /**
     * 城市
     */
    private String city;
    /**
     * 行业
     */
    private String industry;
    /**
     * 联系人
     */
    private String linkman;
    /**
     * 联系电话
     */
    private String telephone;
    /**
     * 注册地址
     */
    private String registeredAddress;
    /**
     * 区域编码
     */
    private Object zoneCode;
    /**
     * 企业照片
     */
    private String departPicture;
    /**
     * 营业执照
     */
    private String businessLicense;
    /**
     * 税务登记
     */
    private String taxRegistration;
    /**
     * 企业照片(代码)到期时间
     */
    private Date departPictureTime;
    /**
     * 营业执照到期时间
     */
    private Date businessLicenseTime;
    /**
     * 税务登记到期时间
     */
    private Date taxRegistrationTime;
    /**
     * 统一社会信用代码
     */
    private String unifiedCreditCode;
    /**
     * 开户行名称
     */
    private String bankName;
    /**
     * 银行卡号
     */
    private String bankCardNumber;
    /**
     * 开户行地址
     */
    private String bankAddress;
    /**
     * 开户行号
     */
    private String bankNo;
    /**
     * 审核状态：01待审核，02已审核，03未通过
     */
    private String auditStatus;
    /**
     * 驳回原因
     */
    private String rejectReason;
    /**
     * 审核人
     */
    private String auditPerson;
    /**
     * 审核时间
     */
    private Date auditTime;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 更新时间
     */
    private Date uptTime;
    /**
     * 更新人
     */
    private String uptPerson;
    /**
     * 删除标识
     */
    private String delFlag;


    public Long getDepartmentId() {
        return departmentId;
    }

    public void setDepartmentId(Long departmentId) {
        this.departmentId = departmentId;
    }

    public String getDepartmentName() {
        return departmentName;
    }

    public void setDepartmentName(String departmentName) {
        this.departmentName = departmentName;
    }

    public String getLegalRepresentative() {
        return legalRepresentative;
    }

    public void setLegalRepresentative(String legalRepresentative) {
        this.legalRepresentative = legalRepresentative;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public String getRegisteredAddress() {
        return registeredAddress;
    }

    public void setRegisteredAddress(String registeredAddress) {
        this.registeredAddress = registeredAddress;
    }

    public Object getZoneCode() {
        return zoneCode;
    }

    public void setZoneCode(Object zoneCode) {
        this.zoneCode = zoneCode;
    }

    public String getDepartPicture() {
        return departPicture;
    }

    public void setDepartPicture(String departPicture) {
        this.departPicture = departPicture;
    }

    public String getBusinessLicense() {
        return businessLicense;
    }

    public void setBusinessLicense(String businessLicense) {
        this.businessLicense = businessLicense;
    }

    public String getTaxRegistration() {
        return taxRegistration;
    }

    public void setTaxRegistration(String taxRegistration) {
        this.taxRegistration = taxRegistration;
    }

    public Date getDepartPictureTime() {
        return departPictureTime;
    }

    public void setDepartPictureTime(Date departPictureTime) {
        this.departPictureTime = departPictureTime;
    }

    public Date getBusinessLicenseTime() {
        return businessLicenseTime;
    }

    public void setBusinessLicenseTime(Date businessLicenseTime) {
        this.businessLicenseTime = businessLicenseTime;
    }

    public Date getTaxRegistrationTime() {
        return taxRegistrationTime;
    }

    public void setTaxRegistrationTime(Date taxRegistrationTime) {
        this.taxRegistrationTime = taxRegistrationTime;
    }

    public String getUnifiedCreditCode() {
        return unifiedCreditCode;
    }

    public void setUnifiedCreditCode(String unifiedCreditCode) {
        this.unifiedCreditCode = unifiedCreditCode;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public String getBankCardNumber() {
        return bankCardNumber;
    }

    public void setBankCardNumber(String bankCardNumber) {
        this.bankCardNumber = bankCardNumber;
    }

    public String getBankAddress() {
        return bankAddress;
    }

    public void setBankAddress(String bankAddress) {
        this.bankAddress = bankAddress;
    }

    public String getBankNo() {
        return bankNo;
    }

    public void setBankNo(String bankNo) {
        this.bankNo = bankNo;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public String getAuditPerson() {
        return auditPerson;
    }

    public void setAuditPerson(String auditPerson) {
        this.auditPerson = auditPerson;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public Date getUptTime() {
        return uptTime;
    }

    public void setUptTime(Date uptTime) {
        this.uptTime = uptTime;
    }

    public String getUptPerson() {
        return uptPerson;
    }

    public void setUptPerson(String uptPerson) {
        this.uptPerson = uptPerson;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

    public String getLinkman() {
        return linkman;
    }

    public void setLinkman(String linkman) {
        this.linkman = linkman;
    }
}