package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * 提现申请(TFinanceCashOut)实体类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:37
 */
@TableName("t_finance_cash_out")
@ApiModel
public class FinanceCashOut implements Serializable {
    private static final long serialVersionUID = 584623943576096734L;
    /**
     * 提现id
     */
    @TableId(value = "cash_out_id",type = IdType.AUTO)
    private Long cashOutId;
    /**
     * 资产id
     */
    private Long assetsId;
    /**
     * 提现金额
     */
    private BigDecimal cashOutMoney;
    /**
     * 提现时间
     */
    private Date cashOutTime;
    /**
     * 审核时间
     */
    private Date auditTime;
    /**
     * 审核人
     */
    private String auditPerson;
    /**
     * 驳回原因
     */
    private String rejectReason;
    /**
     * 付款时间
     */
    private Date payTime;
    /**
     * 付款人
     */
    private String payPerson;
    /**
     * 备注
     */
    private String remark;
    /**
     * 审核状态：01待审核，02审核通过，03未通过
     */
    private String auditStatus;
    /**
     * 创建人
     */
    private String crePerson;
    /**
     * 创建时间
     */
    private Date creTime;
    /**
     * 删除标识
     */
    private String delFlag;


    public Long getCashOutId() {
        return cashOutId;
    }

    public void setCashOutId(Long cashOutId) {
        this.cashOutId = cashOutId;
    }

    public Long getAssetsId() {
        return assetsId;
    }

    public void setAssetsId(Long assetsId) {
        this.assetsId = assetsId;
    }

    public BigDecimal getCashOutMoney() {
        return cashOutMoney;
    }

    public void setCashOutMoney(BigDecimal cashOutMoney) {
        this.cashOutMoney = cashOutMoney;
    }

    public Date getCashOutTime() {
        return cashOutTime;
    }

    public void setCashOutTime(Date cashOutTime) {
        this.cashOutTime = cashOutTime;
    }

    public Date getAuditTime() {
        return auditTime;
    }

    public void setAuditTime(Date auditTime) {
        this.auditTime = auditTime;
    }

    public String getAuditPerson() {
        return auditPerson;
    }

    public void setAuditPerson(String auditPerson) {
        this.auditPerson = auditPerson;
    }

    public String getRejectReason() {
        return rejectReason;
    }

    public void setRejectReason(String rejectReason) {
        this.rejectReason = rejectReason;
    }

    public Date getPayTime() {
        return payTime;
    }

    public void setPayTime(Date payTime) {
        this.payTime = payTime;
    }

    public String getPayPerson() {
        return payPerson;
    }

    public void setPayPerson(String payPerson) {
        this.payPerson = payPerson;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getAuditStatus() {
        return auditStatus;
    }

    public void setAuditStatus(String auditStatus) {
        this.auditStatus = auditStatus;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

}