package com.jz.manage.moduls.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.Date;

/**
 * 组织机构表(TSysOrg)实体类
 *
 * @author Bellamy
 * @since 2020-11-29 14:30:24
 */
@TableName("t_sys_org")
@ApiModel
public class SysOrg implements Serializable {
    private static final long serialVersionUID = 289053694180114461L;
    /**
     * 组织机构id
     */
    @TableId(value = "org_id",type = IdType.AUTO)
    @ApiModelProperty(value = "组织机构id")
    private Long orgId;
    /**
     * 组织名称
     */
    @ApiModelProperty(value = "组织名称")
    private String orgName;
    /**
     * 父组织id
     */
    @ApiModelProperty(value = "父组织id")
    private Long parentOrgId;
    /**
     * 是否子节点：Y是，N否
     */
    @ApiModelProperty(value = "是否子节点：Y是，N否")
    private String ifChild;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date creTime;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String crePerson;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String uptPerson;
    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date uptTime;
    /**
     * 删除标识：Y删除，N未删除
     */
    @ApiModelProperty(value = "删除标识：Y删除，N未删除")
    private String delFlag;


    public Long getOrgId() {
        return orgId;
    }

    public void setOrgId(Long orgId) {
        this.orgId = orgId;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public Long getParentOrgId() {
        return parentOrgId;
    }

    public void setParentOrgId(Long parentOrgId) {
        this.parentOrgId = parentOrgId;
    }

    public String getIfChild() {
        return ifChild;
    }

    public void setIfChild(String ifChild) {
        this.ifChild = ifChild;
    }

    public Date getCreTime() {
        return creTime;
    }

    public void setCreTime(Date creTime) {
        this.creTime = creTime;
    }

    public String getCrePerson() {
        return crePerson;
    }

    public void setCrePerson(String crePerson) {
        this.crePerson = crePerson;
    }

    public String getUptPerson() {
        return uptPerson;
    }

    public void setUptPerson(String uptPerson) {
        this.uptPerson = uptPerson;
    }

    public Date getUptTime() {
        return uptTime;
    }

    public void setUptTime(Date uptTime) {
        this.uptTime = uptTime;
    }

    public String getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(String delFlag) {
        this.delFlag = delFlag;
    }

}