package com.jz.manage.moduls.mapper;

import java.util.List;
import java.util.Map;

import com.jz.common.base.BaseMapper;
import com.jz.common.entity.DataGoods;
import com.jz.manage.moduls.controller.goods.bean.dto.DataGoodsDto;
import com.jz.manage.moduls.controller.goods.bean.dto.DataGoodsListDto;

/**
 * 数据商品(DataGoods)表数据库访问层
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:30
 */
public interface DataGoodsDao extends BaseMapper<DataGoods> {

    /**选择性增加数据商品
     * @param dataGoods
     * @return
     * @throws Exception
     */
    public int insertSelective(DataGoods dataGoods)throws Exception;
    
    /**主键修改数据商品
     * @param dataGoods
     * @return
     * @throws Exception
     */
    public int updateByPrimaryKey(DataGoods dataGoods)throws Exception;

    /**选择性修改数据商品
     * @param dataGoods
     * @return
     * @throws Exception
     */
    public int updateByPrimaryKeySelective(DataGoods dataGoods)throws Exception;
    
    /**主键查询数据商品
     * @param dataGoodsId
     * @return
     * @throws Exception
     */
    public DataGoods selectByPrimaryKey(Long dataGoodsId)throws Exception;

    /**主键删除数据商品
     * @param dataGoodsId
     * @return
     * @throws Exception
     */
    public int deleteByPrimaryKey(Long dataGoodsId)throws Exception;

	/**条件查询数据商品
	 * @param param
	 * @return
	 * @throws Exception
	 */
	public List<DataGoodsListDto> findList(Map<String, Object> param)throws Exception;

	/**主键查询数据商品
	 * @param DataGoodsId
	 * @return
	 * @throws Exception
	 */
	public DataGoodsDto findById(Long dataGoodsId)throws Exception;

	/**批量新增数据商品
	 * @param DataGoodses
	 * @throws Exception
	 */
	public void insertBatch(List<DataGoods> dataGoodses)throws Exception;

}