package com.jz.manage.moduls.service;

import com.jz.common.bean.PageInfoResponse;
import com.jz.common.utils.Result;
import com.jz.manage.moduls.controller.customer.bean.dto.CompanyDetailsDto;
import com.jz.manage.moduls.controller.customer.bean.dto.EnterpriseAuditDto;
import com.jz.manage.moduls.controller.customer.bean.request.EnterpriseAuditRequest;
import com.jz.manage.moduls.controller.customer.bean.request.SaveCustomerRequest;

import javax.servlet.http.HttpServletRequest;

/**
 * 企业(TDepartment)表服务接口
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:35
 */
public interface DepartmentService {


    /**
     * 条件查询企业审核信息列表
     * @param auditRequest
     * @param req
     * @return
     */
    PageInfoResponse<EnterpriseAuditDto> findList(EnterpriseAuditRequest auditRequest, HttpServletRequest req) throws Exception;

    /**
     * 主键获取用户企业详情信息
     * @param id
     * @return
     */
    CompanyDetailsDto selectById(Long id) throws Exception;

    /**
     * 企业审核信息
     * @param id
     */
    void audit(Long id, HttpServletRequest req) throws Exception;

    /**
     * 添加用户
     * @param saveCustomerRequest
     */
    Result add(SaveCustomerRequest saveCustomerRequest, HttpServletRequest req) throws Exception;
}