package com.jz.manage.moduls.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.jz.common.bean.SysUserDto;
import com.jz.common.constant.RedisMessageConstant;
import com.jz.common.constant.ResultCode;
import com.jz.common.constant.ResultMsg;
import com.jz.common.entity.DataGoods;

import com.jz.common.utils.DateUtils;
import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.controller.goods.bean.dto.DataBasicDto;
import com.jz.manage.moduls.controller.goods.bean.dto.DataGoodsApiDto;
import com.jz.manage.moduls.controller.goods.bean.dto.DataInterfaceDto;
import com.jz.manage.moduls.controller.goods.bean.request.DataApiUpReq;

import com.jz.manage.moduls.entity.DataGoodsApi;
import com.jz.manage.moduls.entity.DataGoodsApiParams;
import com.jz.manage.moduls.mapper.DataGoodsApiDao;
import com.jz.manage.moduls.mapper.DataGoodsApiParamsDao;
import com.jz.manage.moduls.mapper.DataGoodsDao;
import com.jz.manage.moduls.service.DataGoodsApiService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * api商品(TDataGoodsApi)表服务实现类
 *
 * @author Bellamy
 * @since 2020-12-01 10:41:31
 */
@Service("dataGoodsApiService")
public class DataGoodsApiServiceImpl implements DataGoodsApiService {
    @Autowired
    private DataGoodsApiDao tDataGoodsApiDao;



    /**
     * 主键查询数据详情
     *
     * @param id
     * @return
     */
    @Override
    public Result selectById(Long id) {
        List<DataGoodsApiDto> dataGoodsApiDto = tDataGoodsApiDao.findById(id);
        if (dataGoodsApiDto.size() == 0) {
            return Result.error(StatusCode.ERROR, "查询异常！");
        }
        // 参数信息
        List<DataGoodsApiDto> list1 = new ArrayList<>();
        List<DataGoodsApiDto> list2 = new ArrayList<>();
        List<DataGoodsApiDto> list3 = new ArrayList<>();
        List<DataGoodsApiDto> list4 = new ArrayList<>();
        List<DataGoodsApiDto> list5 = new ArrayList<>();
        Map<String, Object> map = new HashMap<>();
        // 基本信息
        DataGoodsApiDto dataGoods = dataGoodsApiDto.get(0);
        DataBasicDto dataBasicDto = new DataBasicDto();
        BeanUtils.copyProperties(dataGoods, dataBasicDto);// 赋值

        // 接口文档
        DataInterfaceDto dataInterfaceDto = new DataInterfaceDto();
        BeanUtils.copyProperties(dataGoods, dataInterfaceDto);


        for (DataGoodsApiDto goodsApiDto : dataGoodsApiDto) {
            // 固定参数
            if (goodsApiDto.getParamsDiffNum().equals("01")) {
                list1.add(goodsApiDto);
            }
            // 请求参数
            if (goodsApiDto.getParamsDiffNum().equals("02")) {
                list2.add(goodsApiDto);
            }
            // 响应参数
            if (goodsApiDto.getParamsDiffNum().equals("03")) {
                list3.add(goodsApiDto);
            }
            // 请求头参数
            if (goodsApiDto.getParamsDiffNum().equals("04")) {
                list4.add(goodsApiDto);
            }
            // 状态码参数
            if (goodsApiDto.getParamsDiffNum().equals("05")) {
                list5.add(goodsApiDto);
            }
            // api返回数据样例
            if (!StringUtils.isEmpty(goodsApiDto.getReturnDataExample())) {
                map.put("returnDataExample", goodsApiDto.getReturnDataExample()); // 响应示例
            }
        }
        map.put("dataParam", dataBasicDto); // 基本信息
        map.put("dataInterfaceParam", dataInterfaceDto); // 接口文档
        map.put("pubParam", list1); // 公共参数
        map.put("reqParam", list2); // 请求参数
        map.put("resParam", list3); // 响应参数
        map.put("reqHeadParam", list4); // 请求头参数
        map.put("statusCodeParam", list5); // 状态码参数
        Result result = new Result();
        result.setData(map);
        return Result.of_success(ResultMsg.SUCCESS, result);
    }


}